// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
var host = "http://magnusjobfair.com";
// var host = "http://localhost:8000";
angular.module('magnusApp', ['ionic', 'magnusApp.controllers', 'ngCordova', 'ionic.cloud', 'ion-sticky', 'monospaced.elastic'])
.config(function($ionicCloudProvider) {
  $ionicCloudProvider.init({
    "core": {
      "app_id": "39f64a23"
    }
  });
})
.service('adMob', function () {
  this.show = function () {
    ///Ad Mob
    // var admobid = {};
    if( /(android)/i.test(navigator.userAgent) ) { 
        admobid = { // for Android
            // ca-app-pub-4400805633651159~8290861404
            // banner: 'ca-app-pub-5024561675214186/1470788959',
            banner: 'ca-app-pub-4400805633651159/4152429559',
            interstitial: 'ca-app-pub-XXXXXXXXXXXXXXXX/NNNNNNNNNN'
        };
    } else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
        admobid = { // for iOS
            banner: 'ca-app-pub-5024561675214186/7238120953',
            interstitial: 'ca-app-pub-XXXXXXXXXXXXXXXX/NNNNNNNNNN'
        };
    } else {
        admobid = { // for Windows Phone
            banner: 'ca-app-pub-4400805633651159/4152429559',
            interstitial: 'ca-app-pub-XXXXXXXXXXXXXXXX/NNNNNNNNNN'
        };
    }
    // if(window.AdMob) {
    //     AdMob.createBanner({
    //     adId : admobid.banner, 
    //     isTesting: true,
    //     position:AdMob.AD_POSITION.BOTTOM_CENTER, 
    //     autoShow:true}, function (output) {

    //     }, function (err) {
    //       alert(JSON.stringify(err));
    //     });
    //     //window.AdMob.showBanner('bottom');
    // }

    // window.plugins.AdMob.setOptions( {
    //   publisherId: admobid.banner,
    //   interstitialAdId: admobid.interstitial,
    //   isTesting: true,
    //   bannerAtTop: false, // set to true, to put banner at top 
    //   overlap: false, // set to true, to allow banner overlap webview 
    //   offsetTopBar: false, // set to true to avoid ios7 status bar overlap 
    //   autoShow: true // auto show interstitial ad when loaded 
    // });
    // // display the banner at startup 
    // window.plugins.AdMob.createBannerView();
    
    // create interstitial ad 
    // window.plugins.AdMob.createInterstitialView();
    //   window.plugins.AdMob.showInterstitialAd(
    //     true, 
    //     function(){},
    //     function(e){alert(JSON.stringify(e));}
    //   );
  }
})
.filter('hrefToJS', function ($sce, $sanitize) {
    return function (text) {
      if(text) {
        var regex = /href="([\S]+)"/g;
        var newString = text.replace(regex, "onClick=\"window.open('$1', '_blank', 'location=yes')\"");
        return $sce.trustAsHtml(newString);
      }
    }
})
.filter('limitFromTo', function(){
    return function(input, from, to){
        return (input != undefined)? input.slice(from, to) : '';
    }
})
.run(function($ionicPlatform, $ionicPopup, $state, $httpParamSerializerJQLike, $http, $rootScope, $ionicLoading, $cordovaToast, $ionicSideMenuDelegate, $ionicPopup, $ionicDeploy, $ionicScrollDelegate, $stateParams) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)

    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    $http.defaults.transformRequest.unshift($httpParamSerializerJQLike);
    
    $ionicPlatform.registerBackButtonAction(function (event) {
      if($state.current.name=="app.dashboard" || $state.current.name=="login"){
        var confirmPopup = $ionicPopup.confirm({
           title: "Exit",
           template: "Are you sure you want to exit?"
         });
         confirmPopup.then(function(res) {
           if(res) {
              navigator.app.exitApp(); //<-- remove this line to disable the exit
           } else {
             console.log('You are not sure');
           }
         });
      }
      else {
        navigator.app.backHistory();
      }
    }, 100);

    $rootScope.showLoading = function() {
      $ionicLoading.show({
        template: 'Please wait...',
      }).then(function(){
         console.log("The loading indicator is now displayed");
      });
    };

    $rootScope.showToast = function (message) {
      $cordovaToast.show(message, 'long', 'center')
    }

     $rootScope.showAlert = function(title, message, type) {
       var alertPopup = $ionicPopup.alert({
         title: title,
         template: message,
         okType : type
       });

       alertPopup.then(function(res) {
         console.log('Thank you for not eating my delicious ice cream cone');
       });
     };


    $rootScope.hideLoading = function () {
      $ionicLoading.hide().then(function(){
         console.log("The loading indicator is now hidden");
      });
    }

    if ($ionicSideMenuDelegate.isOpen(true)){
      //some code here
      alert('sidebar opened')
    }

    $rootScope.userinfo = {}
    $rootScope.img_dir = host + '/upload';
    if (window.localStorage.getItem("user")) {
      $rootScope.userinfo = JSON.parse(window.localStorage.getItem("user"));
    }

    $rootScope.developer = "This app was developed by Rolly Domingo";

    $rootScope.dateFormat = function (date, format) {
        n = moment(date).format(format);
        return n;
    }

    $rootScope.ucfirst = function(string) {
      return string.charAt(0).toUpperCase() + string.slice(1);
    }

    $rootScope.ucwords = function (str) {
        return (str + '').replace(/^([a-z])|\s+([a-z])/g, function ($1) {
            return $1.toUpperCase();
        });
    }

    $rootScope.token_loaded = false;
    //alert(device.platform);

    pushNotification = window.plugins.pushNotification;
    pushNotification.register(
      successHandler,
      errorHandler,
      {
        'badge': 'true',
        'sound': 'true',
        'alert': 'true',
        'ecb': 'onNotification',
        'senderID': '384810162935',
      }
    );

    function errorHandler (error) {
    
    }

    function successHandler (result) {
    }

    window.onNotification = function(e){
      switch(e.event){
      case 'registered':
        if(e.regid){
          var device_token = e.regid;
          window.localStorage.setItem("device_token", device_token);
          $rootScope.token_loaded = true;
        }
      break;

      case 'message':
        if ($state.current.name != 'login') {
          var payload = e.payload;
          if (payload.id) {
            var content = e.payload.post_title;
            var confirmPopup = $ionicPopup.confirm({
                title: content,
                template: 'Do you want to see the details of this notification?',
                okType : 'button-positive'
            });

            confirmPopup.then(function(res) {
                if(res) {
                    $state.go('app.notification-view', {id : e.payload.id});
                } else {
                    console.log('You are not sure');
                }
            });
          }
          else {
            if ($state.current.name == 'app.contact-mei-chat') {
              if ($stateParams.id == payload.raw_data.company_id) {
                $rootScope.messages.push(payload.raw_data);
                $rootScope.$digest();
                setTimeout(function () {
                  $ionicScrollDelegate.scrollBottom(true);
                }, 1000);
              }
              else {
                var confirm = $ionicPopup.confirm({
                  title : 'A new message from MEI',
                  template : payload.message,
                  okType : 'button-positive',
                  okText : 'Reply Now',
                  cancelType : 'button-stable',
                  cancelText : 'Reply Later'
                });

                confirm.then(function (res) {
                  if (res) {
                    if (payload.raw_data.owner == 'company') {
                      $state.go('app.contact-mei-chat', {id : payload.raw_data.company_id});
                    }
                    else {
                      $state.go('app.contact-mei-chat', {id : 0});
                    }
                  }
                });
              }
            }
            else {
              var confirm = $ionicPopup.confirm({
                title : 'A new message from MEI',
                template : payload.message,
                okType : 'button-positive',
                okText : 'Reply Now',
                cancelType : 'button-stable',
                cancelText : 'Reply Later'
              });

              confirm.then(function (res) {
                if (res) {
                  if (payload.raw_data.owner == 'company') {
                    $state.go('app.contact-mei-chat', {id : payload.raw_data.company_id});
                  }
                  else {
                    $state.go('app.contact-mei-chat', {id : 0});
                  }
                }
              });
            }
          }
        }
      break;

      case 'error':
        alert('error occured');
      break;

      }
    };

    var date = new Date();
    $rootScope.timenow = date.getTime();
    $rootScope.unread = 0;

    window.errorHandler = function(error){
      alert('an error occured');
    }

    $ionicDeploy.channel = 'production';
    $ionicDeploy.channel = 'dev';
    $ionicDeploy.check().then(function(snapshotAvailable) {
      if (snapshotAvailable) {
        $ionicDeploy.download().then(function() {
           var confirmPopup = $ionicPopup.confirm({
              title: "Install Updates",
              template: "Updates are now ready, do you want to restart now?",
              cancelText: 'No',
              okText: 'Yes',
              okType : 'button-positive',
              cancelType : 'button-positive button-outline'
          });
          confirmPopup.then(function(res) {
              if(res) {
                  $ionicDeploy.load();
                  return $ionicDeploy.extract();
              }
          });
        }, function (err) {
          $rootScope.showToast("Something went wrong. Please try again later.");
        }, function (progress) {
          console.log(progress);
        });
      }
    });
  });
})


.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

  .state('login', {
    url : '/login',
    templateUrl : 'templates/login.html',
    controller : 'loginCtrl'
  })
  .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'sideMenuCtrl'
  })
  .state('app.profile', {
    url : '/profile',
    views : {
      'menuContent' : {
        templateUrl : 'templates/profile.html',
        controller : 'profileCtrl'
      }
    }
  })
  .state('app.dashboard', {
    url : '/dashboard',
    views : {
      'menuContent' : {
        templateUrl : 'templates/dashboard.html',
        controller : 'dashboardCtrl'
      }
    }
  })
  .state('app.event-group', {
    url : '/event-group/:category',
    views : {
      'menuContent' : {
        templateUrl : 'templates/event-group.html',
        controller : 'eventGroupCtrl'
      }
    }
  })
  .state('app.exclusive-events', {
    url : '/exclusive-events/:category',
    views : {
      'menuContent' : {
        templateUrl : 'templates/exclusive-events.html',
        controller : 'exclusiveEventsCtrl'
      }
    }
  })
  .state('app.featured-companies', {
    url : '/featured-companies',
    views : {
      'menuContent' : {
        templateUrl : 'templates/featured-companies.html',
        controller : 'featuredCompaniesCtrl'
      }
    }
  })
  .state('app.view-event', {
    url : '/view-event/:id/:category',
    views : {
      'menuContent' : {
        templateUrl : 'templates/event-details.html',
        controller : 'eventDetailCtrl'
      }
    }
  })
  .state('app.view-event-exhibitor', {
    url : '/view-event-exhibitor/:id/:category/:event_id/:applied',
    views : {
      'menuContent' : {
        templateUrl : 'templates/event-exhibitor-details.html',
        controller : 'eventExhibitorCtrl'
      }
    }
  })
  .state('app.view-company-event', {
    url : '/view-company-event/:id',
    views : {
      'menuContent' : {
        templateUrl : 'templates/event-company.html',
        controller : 'eventCompanyCtrl'
      }
    }
  })
  .state('app.view-featured-company', {
    url : '/view-featured-company/:id',
    views : {
      'menuContent' : {
        templateUrl : 'templates/featured-company-details.html',
        controller : 'featuredCompanyDetailsCtrl'
      }
    }
  })
  .state('app.contact-mei', {
    url : '/contact-mei',
    views : {
      'menuContent' : {
        templateUrl : 'templates/contact-mei.html',
        controller : 'contactMeiCtrl'
      }
    }
  })
  .state('app.contact-mei-details', {
    url : '/contact-mei/:id',
    views : {
      'menuContent' : {
        templateUrl : 'templates/contact-mei-details.html',
        controller : 'ContactMeiDetailsCtrl'
      }
    }
  })
  .state('app.contact-mei-add', {
    url : '/contact-mei-add',
    views : {
      'menuContent' : {
        templateUrl : 'templates/contact-mei-add.html',
        controller : 'ContactMeiAddCtrl'
      }
    }
  })
  .state('app.contact-mei-chat', {
    url : '/contact-mei-chat/{id}',
    views : {
      'menuContent' : {
        templateUrl : 'templates/contact-mei-chat.html',
        controller : 'ContactMeiChatCtrl'
      }
    }
  })
  .state('app.notifications', {
    url : '/notifications',
    views : {
      'menuContent' : {
        templateUrl : 'templates/notifications.html',
        controller : 'notificationsCtrl'
      }
    }
  })
  .state('app.notification-view', {
    url : '/notification/:id',
    views : {
      'menuContent' : {
        templateUrl : 'templates/notification-view.html',
        controller : 'notificationViewCtrl'
      }
    }
  })
  .state('app.referrals', {
    url : '/referrals',
    views : {
      'menuContent' : {
        templateUrl : 'templates/referrals.html',
        controller : 'referralCtrl'
      }
    }
  })
  .state('app.about', {
    url : '/about',
    views : {
      'menuContent' : {
        templateUrl : 'templates/about.html',
        controller : 'aboutCtrl'
      }
    }
  })
  .state('app.search-jobs', {
    url : '/search-jobs',
    views : {
      'menuContent' : {
        templateUrl : 'templates/search-jobs.html',
        controller : 'searchJobCtrl'
      }
    }
  })
  .state('app.im-hired', {
    url : '/im-hired',
    views : {
      'menuContent' : {
        templateUrl : 'templates/im-hired.html',
        controller : 'imHiredCtrl'
      }
    }
  })
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/login');
});
