angular.module('magnusApp.controllers', [])
.controller('sideMenuCtrl', ['$scope', '$ionicModal', '$timeout', '$state', '$ionicSideMenuDelegate', '$ionicAuth', '$ionicPopup', '$ionicHistory', '$timeout', '$http', '$ionicSlideBoxDelegate', '$rootScope',
    function($scope, $ionicModal, $timeout, $state, $ionicSideMenuDelegate, $ionicAuth, $ionicPopup, $ionicHistory,  $timeout, $http, $ionicSlideBoxDelegate, $rootScope) {
        $scope.display_applications = false;
        $rootScope.userinfo = JSON.parse(window.localStorage.getItem("user"));

        $scope.showLoading();
        var req = {
            url : host + '/api/v2/get-unread-notifications',
            method : 'GET',
            params : {token : $scope.userinfo.token}
        }

        $http(req).then(function successCallback(output) {
            $scope.hideLoading();
            var response = output.data;
            if (response.status == 'success') {
                $rootScope.unread = response.data.unread;
            }
            else {
                $scope.showAlert("Failed", response.message);
            }
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed \n Please try again.");
        })

        $scope.MyApplications = function () {
            $scope.display_applications = !$scope.display_applications;
        }

        $scope.redirect = function (state) {
            $state.go(state);
        }

        $scope.logout = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: "Log-out",
                template: "Are you sure you want to log-out now?",
                cancelText: 'No',
                okText: 'Yes',
                okType : 'button-positive',
                cancelType : 'button-positive button-outline'
            });
            confirmPopup.then(function(res) {
                if(res) {
                    $scope.showLoading();
                    $timeout(function () {
                        try{
                            pushNotification.unregister(function () {
                                
                            }, function () {

                            }, {});    
                        }
                        catch (err) {
                            console.log(err);
                        }
                        
                        $ionicHistory.clearHistory();
                        $ionicHistory.clearCache().then(function(){
                            $scope.hideLoading();
                            window.localStorage.setItem("device_token", "");
                            window.localStorage.setItem("user", "");
                            $state.go('login');
                        });
                    },400)
                    if ($scope.userinfo.registration_type == 'facebook') {
                        $ionicAuth.logout();
                    }
                }
            });
        }
    }
])
.controller('loginCtrl', ['$scope', '$state', '$http', '$ionicAuth', '$ionicUser', '$rootScope', '$ionicHistory', '$ionicPlatform', '$ionicModal', '$cordovaDatePicker',
    function ($scope, $state, $http, $ionicAuth, $ionicUser, $rootScope, $ionicHistory, $ionicPlatform, $ionicModal, $cordovaDatePicker) {
        $ionicModal.fromTemplateUrl('templates/modal/forgot-password.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_forgot = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/cities-list.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_cities = modal;
        });

        $scope.tab_login = true;

        $scope.changeTab = function (t) {
            $scope.tab_login = t;
        }

        $ionicPlatform.ready(function () {
            if (window.localStorage.getItem("user")) {
                $scope.showLoading();
                setTimeout(function () {
                    $state.go('app.dashboard');
                    $scope.hideLoading();
                }, 1000)
            }
        });

        if (ionic.Platform.isIOS()) {
            alert("IOS");
            $scope.platform = 'ios';
        }
        else if (ionic.Platform.isAndroid()) {
            $scope.platform = 'android';         
        }

        $scope.forgotPassword = function () {
            $scope.modal_forgot.show();
        }
        $scope.forgot = {};
        $scope.forgotPasswordProcess = function () {
            $scope.showLoading();
            var req = {
                url : host + '/api/v2/forgot-password',
                method : 'POST',
                data : {email : $scope.forgot.email},
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.showToast('New Password has been sent to your email.');
                    $scope.forgot = {};
                    $scope.modal_forgot.hide();
                }
                else {
                    $scope.showAlert("Failed", response.message);
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            });
        }

        $scope.login = function () {
            $scope.showLoading();
            var device_token = window.localStorage.getItem('device_token') ? window.localStorage.getItem('device_token') : '-';
            var req = {
                url : host + '/api/v2/login',
                method : 'POST',
                data : {username : $scope.login.username, password : $scope.login.password, device_token: device_token},
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }
            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.hideLoading();
                    window.localStorage.setItem('user', JSON.stringify(response.data));
                    $rootScope.userinfo = response.data;
                    $state.go('app.dashboard'); 
                }
                else {
                    $scope.hideLoading();
                    $scope.showAlert('Login Faied', 'Invalid Credentials', 'button-positive');
                }
            }, function errorCallback(err) {

            });
            
        }


        $scope.fblogin = function () {
            $scope.showLoading();   
            $ionicAuth.login('facebook').then(function successCallback (output) {
                if (output.token) {
                    var response = $ionicUser.social.facebook.data.raw_data;
                    var params = {
                        fullname : response.name,
                        picture : 'http://graph.facebook.com/'+ response.id +'/picture?height=200&width=200',
                        first_name : response.first_name,
                        last_name : response.last_name,
                        email : response.email,
                        id : response.id,
                        device_token : window.localStorage.getItem('device_token'),
                        download_type : $scope.platform
                    }

                    var fbreq = {
                        url : host + '/api/v2/fb-login',
                        method : 'POST',
                        data: params,
                        headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                    }

                    $http(fbreq).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            window.localStorage.setItem("user", JSON.stringify(response.data));
                            $rootScope.userinfo = response.data;
                            $scope.showToast(response.message);
                            $state.go('app.dashboard');
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                        $scope.hideLoading();
                    });
                }

            }, function errorCallback(err) {
                $scope.hideLoading();
            });

        }

        $scope.ctr = 0;
        $scope.showName = function () {
            $scope.ctr = $scope.ctr + 1;
            if ($scope.ctr >= 21) {
                $scope.showToast($scope.developer);
                $scope.ctr = 0; 
            }
        }

        $scope.signup = {};

        $scope.signUpProcess = function () {
            $scope.signup.download_type = $scope.platform;
            $scope.signup.device_token = window.localStorage.getItem("device_token");
            $scope.showLoading();
            var req = {
                url : host + '/api/v2/sign-up',
                method : 'POST',
                data : $scope.signup,
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    window.localStorage.setItem("user", JSON.stringify(response.data));
                    $rootScope.userinfo = response.data;
                    $scope.showToast(response.message);
                    $state.go('app.dashboard');
                }
                else {
                    $scope.showAlert('Sign-up Failed', response.message, 'button-assertive');
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            })
        }

        $scope.setBirthDate = function () {
            var options = {
                date: new Date(),
                mode: 'date', // or 'time'
                minDate: 0,
                allowOldDates: true,
                allowFutureDates: true,
                doneButtonLabel: 'DONE',
                doneButtonColor: '#F2F3F4',
                cancelButtonLabel: 'CANCEL',
                cancelButtonColor: '#000000'
            };

            document.addEventListener("deviceready", function () {
                $cordovaDatePicker.show(options).then(function(date){
                    $scope.signup.birthdate = moment(date).format('MMM DD, YYYY');
                });
            }, false);
        }

        $scope.showCities = function () {
            $scope.cities = cities;
            $scope.modal_cities.show();
        }

        $scope.selectCity = function (c) {
            $scope.signup.city = c.city_name;
            $scope.modal_cities.hide();
        }

    }
])
.controller('dashboardCtrl', ['$scope', '$http', '$cordovaAdMob', '$state', '$ionicPopup', '$ionicSlideBoxDelegate', 'adMob',
	function ($scope, $http, $cordovaAdMob, $state, $ionicPopup, $ionicSlideBoxDelegate, adMob) {
        $scope.$on( "$ionicView.enter", function( scopes, states ) {
            $ionicSlideBoxDelegate.update();
        });
        $scope.showLoading();
        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        var req = {
            url : host + '/api/v2/dashboard',
            method : 'POST',
            data : { token : userinfo.token},
            headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
        };

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.mega = response.data.mega;
                $scope.provincial = response.data.provincial;
                $scope.exclusive = response.data.exclusive;
                $scope.featured = response.data.featured;

                var info_arr = [];
                // if (!response.data.profile.middle_name){
                //     info_arr.push({name : "Middle Name"});
                // }
                if (!response.data.profile.mobile_1){
                    info_arr.push({name : "Primary Mobile Number"});
                }
                // if (!response.data.profile.mobile_2){
                //     info_arr.push({name : "Secondary Mobile Number"});
                // }
                // if (!response.data.profile.landline){
                //     info_arr.push({name : "Landline"});
                // }
                if (!response.data.profile.home_address){
                    info_arr.push({name : "Home Address"});
                }
                if (!response.data.profile.city_municipality){
                    info_arr.push({name : "City/Municipality"});
                }
                if (!response.data.profile.birthdate){
                    info_arr.push({name : "Birthdate"});
                }
                if (!response.data.profile.gender){
                    info_arr.push({name : "Gender"});
                }
                // if (!response.data.profile.card_no){
                //     info_arr.push({name : "Card Number"});
                // }
                if (info_arr.length > 0) {
                    var template = '<p>These field(s) is/are required.</p>';
                    for (i in info_arr) {
                        template += '-'+ info_arr[i].name + '<br/>';
                    }
                    template += '<br/><p>Please update your profile now.</p>';
                    var confirm = $ionicPopup.alert({
                        title : 'Please complete your profile',
                        template : template,
                    });
                    confirm.then(function (res) {
                        if (res) {
                          $state.go('app.profile');  
                        }
                    });
                }
            }
            $scope.hideLoading();

        }, function errorCallback (err) {
            $scope.showAlert("Connection error", "Connection Failed. \n Please check your internet connection and try again.")
            $scope.hideLoading();
        });


        var req = {
            url : host + '/api/v2/get-ads',
            method : 'GET',
            params : {token : $scope.userinfo.token}
        }
        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.ads = response.data;
                $ionicSlideBoxDelegate.update();
            }
            else {
                $scope.showAlert("Failed", response.message);
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
        });


        $scope.getEventDetails = function (id, category) {
            if (category == 3) {
                $state.go('app.view-company-event', {id : id});
            }
            else if (category == 4) {
                $state.go('app.view-featured-company', {id : id});
            }
            else {
                $state.go('app.view-event', {id : id, category : category});
            }
        }

        $scope.refreshList = function () {
            var req = {
                url : host + '/api/v2/dashboard',
                method : 'POST',
                data : { token : userinfo.token},
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            };

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.mega = response.data.mega;
                    $scope.provincial = response.data.provincial;
                    $scope.exclusive = response.data.exclusive;
                    $scope.featured = response.data.featured;
                }

                $scope.hideLoading();
                $scope.$broadcast('scroll.refreshComplete');
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        $scope.searchJob = function () {
            $state.go('app.search-jobs');
        }

        setTimeout(function () {
            adMob.show();
        }, 1500);
	}
])
.controller('eventGroupCtrl', ['$scope', '$http', '$stateParams',
    function ($scope, $http, $stateParams) {
        $scope.categories = {1 : 'Metro Manila Job Fairs', 2 : 'Provincial Job Fairs', 3 : 'Exclusive Carreer Fair Events', 4 : 'Featured Companies', };
        $scope.title = $scope.categories[$stateParams.category]
        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        $scope.status = 'active';
        
        $scope.refresh = function(t) {
            $scope.showLoading();
            var req = {
                url : host + '/api/v2/get-events/' + $stateParams.category,
                method : 'GET',
                params : {token : userinfo.token, status : t}
            }
            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.events = response.data;
                    $scope.status = t;
                }
                else {
                    //$scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                }
                $scope.hideLoading();
                $scope.$broadcast('scroll.refreshComplete');
            }, function errorCallback (err) {
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                $scope.hideLoading();
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        $scope.refresh('active');
        $scope.changeStatus = function (t)  {
            $scope.refresh(t);
        }
    }
])
.controller('exclusiveEventsCtrl', ['$scope', '$http', '$stateParams',
    function ($scope, $http, $stateParams) {
        $scope.status = 'active';
        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        $scope.reload = function (t) {
            $scope.showLoading();
            var req = {
                url : host + '/api/v2/get-exclusive-events',
                method : 'GET',
                params : {token : userinfo.token, status : t}
            }
            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.events = response.data;
                    $scope.status = t;
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
            })
        }

        $scope.reload('active');

        $scope.changeStatus = function (t) {
            $scope.reload(t);
        }
    }
])
.controller('featuredCompaniesCtrl', ['$scope', '$http',
    function ($scope, $http) {
        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        $scope.reload = function (t) {
            $scope.showLoading();
            var req = {
                url : host + '/api/v2/get-featured-companies',
                method : 'GET',
                params : {token : userinfo.token, status : t}
            }
            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.companies = response.data;
                    $scope.status = t;
                }
                $scope.hideLoading();
                $scope.$broadcast('scroll.refreshComplete');
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.$broadcast('scroll.refreshComplete');
            })
        }
        $scope.reload('active');
    }
])
.controller('eventDetailCtrl', ['$scope', '$http', '$stateParams', '$ionicPopup', '$ionicModal', '$state', '$cordovaSocialSharing',
    function ($scope, $http, $stateParams, $ionicPopup, $ionicModal, $state, $cordovaSocialSharing) {
        $ionicModal.fromTemplateUrl('templates/modal/event-apply-code.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_code = modal;
        });
        $scope.showLoading();
        console.log($stateParams);
        var req = {
            url : host + '/api/v2/event-details/' + $stateParams.id + '?token=' + $scope.userinfo.token,
            method : 'GET'
        }
        $scope.applied = false;
        $scope.application_code = '';

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.participants = response.data.participants;
                $scope.eventDetails = response.data.details;
                $scope.eventDates = response.data.dates.join("<br/>");
                var req_application = {
                    url : host + '/api/v2/check-application',
                    method : 'POST',
                    data : {
                        event_id : $stateParams.id,
                        category_id : $stateParams.category,
                        token : $scope.userinfo.token,
                    },
                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                }

                $http(req_application).then(function successCallback (output) {
                    var response = output.data;
                    if (response.status == 'success') {
                        if (response.data.applied == 0) {
                            $scope.applied = false;
                            $scope.application_code = '';
                        }
                        else {
                            $scope.applied = true;
                            $scope.application_code = response.data.application_code;
                            $scope.venue = response.data.place;
                            $scope.dates = response.data.dates;
                            $scope.start_time = response.data.time_from;
                            $scope.end_time = response.data.time_to; 
                        }
                    }
                    $scope.hideLoading();
                }, function errorCallback (err) {
                    $scope.hideLoading();
                    $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                })
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            $scope.hideLoading();
        })

        $scope.apply = function () {
            if (!$scope.applied) {
                $scope.showLoading();
                var req = {
                    url : host + '/api/v2/apply',
                    method : 'POST',
                    data : {
                        token : $scope.userinfo.token,
                        account_id : $scope.userinfo.account_id,
                        company_id : 0,
                        category_id : $stateParams.category,
                        event_id : $stateParams.id
                    },
                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                }
                $http(req).then(function successCallback (output) {
                    var response = output.data;
                    if (response.status == 'success') {
                        $scope.application_code = response.data.application_code;
                        $scope.venue = response.data.place;
                        $scope.dates = response.data.dates;
                        $scope.start_time = response.data.time_from;
                        $scope.end_time = response.data.time_to; 
                        $scope.applied = true;

                        $scope.modal_code.show();
                    }
                    $scope.hideLoading();
                    // $scope.showToast(response.message);
                }, function errorCallback (err) {
                    $scope.hideLoading();
                    $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                });
            }
            else {
                $scope.modal_code.show();
            }
        }

        $scope.viewPartnerDetals = function (p) {
            if (p.clickable == 'true') {
                var category = $stateParams.category;
                var applied = $scope.applied;
                $state.go('app.view-event-exhibitor', 
                {
                    id : p.company_id, 
                    category : category, 
                    event_id : $stateParams.id, 
                    applied : applied
                });
            }
        }

        $scope.viewCompany = function (id) {
            var category = $stateParams.category;
            var applied = $scope.applied;
            $state.go('app.view-event-exhibitor', 
                    {
                        id : id, 
                        category : category, 
                        event_id : $stateParams.id, 
                        applied : applied
                    });
        }

        $scope.getTime = function (time) {
            n = moment("2017-01-01 " + time).format('hh:mm A');
            return n;
        }

        $scope.share = function () {
            $scope.showLoading();
            $cordovaSocialSharing
            .shareViaFacebook('Share This Event', null, $scope.eventDetails.fb_link)
            .then(function(result) {
              // Success!
              $scope.hideLoading()
            }, function(err) {
                 $scope.showToast("Something went wrong, please try again");
                $scope.hideLoading()
              // An error occurred. Show a message to the user
            });
        }
    }
])
.controller('featuredCompanyDetailsCtrl', ['$scope', '$state', '$http', '$stateParams', '$ionicPopup', '$ionicModal', '$sce',
    function ($scope, $state, $http, $stateParams, $ionicPopup, $ionicModal, $sce) {
        $ionicModal.fromTemplateUrl('templates/modal/profile.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_profile = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/company-video.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_video = modal;
        });

        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        $scope.showLoading();
        var req = {
            url : host + '/api/v2/featured-company-details/' + $stateParams.id,
            method : 'GET',
            params : {token : userinfo.token},
        }

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.details = response.data.details;
                $scope.vacancies = response.data.vacancies;
                $scope.is_applied = response.data.is_applied;
                if ($scope.details.company_profile) {
                    $scope.details.company_profile_excerpt = $scope.details.company_profile.length >= 200 ? $scope.details.company_profile.replace(/<(?:.|\n)*?>/gm, '').substring(0, 200) + '...' : $scope.details.company_profile
                }
                else {
                    $scope.details.company_profile_excerpt = '';   
                }
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
        });

        $scope.htmlConvert = function (string) {
            return $sce.trustAsHtml(string);
        }

        $scope.hideModalProfile = function () {
            alert("Test");
        }

        $scope.app = {};
        $scope.app.source = '';
        $scope.apply = function () {
            $scope.showLoading()
            var req = {
                url : host + '/api/v2/featured-company-apply',
                method : 'POST',
                data : {token : userinfo.token, company_id : $stateParams.id, source : $scope.app.source},
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.is_applied = 1;
                }
                $scope.showToast(response.message);
                $scope.hideLoading()
            }, function errorCallback (err) {
                $scope.hideLoading();
            })
        }

        $scope.startCompanyVideo = function () {
            $scope.modal_video.show();
            var video = document.getElementById('iframe-video');
            if ($scope.details.video) {
                video.src = 'http://magnusjobfair.com/upload/video/company/' + $scope.details.video;
            }
            else {
                video.src = '';
            }
        }

        $scope.stopCompanyVideo = function () {
            $scope.modal_video.hide();
            var video = document.getElementById('video');
            var video = document.getElementById('iframe-video');
            video.src = '';
        }
    }
])
.controller('eventExhibitorCtrl', ['$scope', '$http', '$ionicPopup', '$ionicModal', '$stateParams', '$cordovaSocialSharing', '$sce',
    function ($scope, $http, $ionicPopup, $ionicModal, $stateParams, $cordovaSocialSharing, $sce) {
        $ionicModal.fromTemplateUrl('templates/modal/event-apply-code.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_code = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/profile.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_profile = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/company-video.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_video = modal;
        });

        $scope.showLoading();
        $scope.applied = $stateParams.applied == 'true' ? true : false;

        var req = {
            url : host + '/api/v2/participant-details/' + $stateParams.id + '/' + $stateParams.event_id,
            method : 'POST',
            data : {
                token : $scope.userinfo.token,
            },
            headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
        }

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.details = response.data.details;
                $scope.jobs = response.data.jobs;

                if (response.data.event_details) {
                    var short_profile = response.data.event_details.profile;
                    $scope.details.short_profile = short_profile.length > 200 ? short_profile.replace(/<(?:.|\n)*?>/gm, '').substring(0, 200) + " ..." : short_profile;
                    $scope.details.company_profile = response.data.event_details.profile;
                }
                else {
                    var short_profile = response.data.details.company_profile;
                    $scope.details.short_profile = short_profile.length > 200 ? short_profile.replace(/<(?:.|\n)*?>/gm, '').substring(0, 200) + " ..." : short_profile;
                    $scope.details.company_profile = response.data.details.company_profile;
                }
            
                console.log(response.data);
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
        });

        $scope.htmlConvert = function (string) {
            if ($sce.trustAsHtml(string)) {
                return $sce.trustAsHtml(string);
            }
            else {
                return string;
            }
        }

        $scope.eventApply = function () {
            if ($scope.applied) {
                $scope.showLoading();
                var req_application = {
                    url : host + '/api/v2/check-application',
                    method : 'POST',
                    data : {
                        event_id : $stateParams.event_id,
                        category_id : $stateParams.category,
                        token : $scope.userinfo.token
                    },
                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                }
                $http(req_application).then(function successCallback (output) {
                    var response = output.data;
                    if (response.status == 'success') {
                        $scope.application_code = response.data.application_code;
                        $scope.venue = response.data.place;
                        $scope.dates = response.data.dates;
                        $scope.start_time = response.data.time_from;
                        $scope.end_time = response.data.time_to; 
                        $scope.applied = true;
                        $scope.modal_code.show();
                    }
                    $scope.hideLoading();
                }, function errorCallback (err) {
                    $scope.hideLoading();
                    $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                })
                
            }
            else {
                var confirmPopup = $ionicPopup.confirm({
                    title: "Apply Confirmation",
                    template: "Are you sure you want to apply to this event?",
                    cancelText: 'No',
                    okText: 'Yes',
                    okType : 'button-positive',
                    cancelType : 'button-positive button-outline'
                });
                confirmPopup.then(function(res) {
                    if(res) {      

                    }
                });
            }
        }

        $scope.showFullProfile = function () {
            $scope.modal_profile.show();
        }

        $scope.share = function () {
            $scope.showLoading();
            $cordovaSocialSharing
            .shareViaFacebook('Share This Event', null, $scope.details.fb_link)
            .then(function(result) {
              // Success!
              $scope.hideLoading()
            }, function(err) {
                 $scope.showToast("Something went wrong, please try again");
                $scope.hideLoading()
              // An error occurred. Show a message to the user
            });
        }

        $scope.startCompanyVideo = function () {
            $scope.modal_video.show();
            var video = document.getElementById('iframe-video');
            if ($scope.details.video) {
                video.src = 'http://magnusjobfair.com/upload/video/company/' + $scope.details.video;
            }
            else {
                video.src = '';
            }
        }

        $scope.stopCompanyVideo = function () {
            $scope.modal_video.hide();
            var video = document.getElementById('video');
            var video = document.getElementById('iframe-video');
            video.src = '';
        }
    }
])
.controller('eventCompanyCtrl', ['$scope', '$http', '$stateParams', '$ionicModal', '$ionicPopup', '$sce',
    function ($scope, $http, $stateParams, $ionicModal, $ionicPopup, $sce) {
        $ionicModal.fromTemplateUrl('templates/modal/profile.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_profile = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/job-vacancies.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_job_vancancies = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/job-details.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_job = modal;
        });

        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        var req = {
            url : host + '/api/v2/exclusive-fair-event-details/' + $stateParams.id + '?token=' + $scope.userinfo.token,
            method : 'GET'
        }

        $scope.showLoading();
        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                var profile = response.data.company.company_profile;
                $scope.details = response.data.company;
                $scope.details.company_profile_excerpt = profile.length >=200 ? profile.replace(/<(?:.|\n)*?>/gm, '').substring(0, 200) + '...' : profile;
                $scope.events = response.data.events;
                $scope.applicant_id = response.data.applicant_id;
                $scope.job_vacancies = response.data.vacancies;
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showAlert("Connection Faile", "Connection Failed. \n Please check your internet connection and try again.")
        });

        $scope.viewJobDetails = function (idx) {
            $scope.job = $scope.job_vacancies[idx];
            $scope.modal_job.show();
        }

        $scope.viewJobVacancies = function (event_id, company_id) {
            var req = {
                url : host + '/api/v2/get-job-vacancies?company_id=' + company_id + '&event_id=' + event_id + '&token=' + $scope.userinfo.token,
                method : 'GET'
            }

            $http(req).then(function (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.job_vacancies = response.data;
                    $scope.modal_job_vancancies.show();    
                }

                $scope.hideLoading();
                
            }, function(err) {

            });
        }

        $scope.getDates = function(idx) {
            if ($scope.events[idx]) {
               return $scope.events[idx].dates.join(' - ');
            }
        }
        $scope.htmlConvert = function (string) {
            if ($sce.trustAsHtml(string)) {
                return $sce.trustAsHtml(string);
            }
            else {
                return string;
            }
        }

        $scope.app = {};
        $scope.apply = function (id, idx) {
            var myPopup = $ionicPopup.show({
                template: '<input type="text" ng-model="app.source" placeholder="Enter your source here..">',
                title: 'Enter your source',
                scope: $scope,
                buttons: [
                  { text: 'Cancel', type: 'button-positive button-outline'},
                  {
                    text: '<b>Submit</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                        $scope.showLoading();
                        var req = {
                            url : host + '/api/v2/exclusive-fair-event-apply',
                            method : 'POST',
                            data : {
                                source : $scope.app.source,
                                token : userinfo.token,
                                event_id : id,
                                company_id : $stateParams.id
                            },
                            headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                            }

                            $http(req).then(function successCallback (output) {
                            var response = output.data;
                            if (response.status == 'success') {
                                $scope.events[idx].is_applied = 1;
                                $scope.showAlert("This is to confirm your application for " + $scope.details.company_name + ",\
                                 see you on " + $scope.getDates(idx) + " at " + $scope.events[idx].place + ".<br/> Expect a call from our phone screeners");
                            }
                            else {
                                $scope.showAlert("Failed", response.message);
                            }
                                $scope.hideLoading();
                            }, function errorCallback (err) {
                            $scope.hideLoading();
                        });
                    }
                  }
                ]
            });
        }
    }
])
.controller('profileCtrl', ['$scope', '$state', '$http', '$ionicHistory', '$ionicModal', '$ionicPopup', '$cordovaDatePicker', '$cordovaCamera', '$cordovaFileTransfer', '$rootScope', '$cordovaFile', '$timeout', '$cordovaFileOpener2', '$ionicLoading', '$cordovaInAppBrowser',
    function ($scope, $state, $http, $ionicHistory, $ionicModal, $ionicPopup, $cordovaDatePicker, $cordovaCamera, $cordovaFileTransfer, $rootScope, $cordovaFile, $timeout, $cordovaFileOpener2, $ionicLoading, $cordovaInAppBrowser) {
        $ionicModal.fromTemplateUrl('templates/modal/edit-profile.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_edit_profile = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/cities-list.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_cities = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/award-year.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_award_year = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/add-objective.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_objective = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/education-modal.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_education = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/experience-modal.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_experience = modal;
        });


        $ionicModal.fromTemplateUrl('templates/modal/add-skill.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_skill = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/add-interest.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_interest = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/add-reference.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_reference = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/add-award.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_award = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/educ-attainment.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_attainment = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/emp-status.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_emp_status = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/reset-password.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_reset = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/documents.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_document = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/documents-uploaded.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_uploaded_document = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/add-seminar.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_seminar = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modal/add-affiliation.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_affiliation = modal;
        });

        var datenow = new Date();
        var year = moment(datenow).format('YYYY');
        var year_before = year - 30;

        $scope.years = [];
        for (y = year_before; y <= year; y++) {
            $scope.years.unshift({year : y})
        }
        

        $scope.showLoading();
        $scope.objective = {};
        $scope.education = {};
        $scope.exp = {};
        $scope.app = {};
        $scope.interest = {};
        $scope.ref = {};
        $scope.skills_arr = [];
        $scope.deleted_skills_arr = [];
        $scope.reset = {};
        $scope.employment_status = [
            {name : 'Employed'},
            {name : 'Unemployed'},
            {name : 'Displaced'}
        ];
        var userinfo = JSON.parse(window.localStorage.getItem("user"));

        $scope.openResume = function () {
            var options = {
                location: 'yes',
                clearcache: 'yes',
                toolbar: 'no'
            };

            var link = host + '/view-resume?token=' + userinfo.token;
            console.log(link);
            var glink = "http://docs.google.com/viewer?url=" +  encodeURIComponent(link) + "&embedded=true";

            $cordovaInAppBrowser.open(glink, '_blank', options)
              .then(function(event) {
                // success
              })
              .catch(function(event) {
                // error
              });

        }

        $scope.sendResume = function () {
            $scope.showLoading();
            var req = {
                url : host + '/api/send-resume?token=' + userinfo.token,
                method : 'GET'
            }

            $http(req).then(function (output) {
                var response = output.data;
                if(response.status == 'success') {
                    $scope.showToast(response.message);
                }
                else {
                    $scope.showToast(response.message);
                }
                $scope.hideLoading();
            }, function (err) {
                $scope.hideLoading();
                $scope.showToast("Something went wrong, Please try again.");
            });
        }

        $scope.resetPassword = function () {
            $scope.modal_reset.show();
        }
        $scope.resetPasswordProcess = function () {
            $scope.reset.token = userinfo.token;
            var confirm = $ionicPopup.confirm({
                title : 'Rest Password',
                template : 'Are you sure you want to reset your password?',
                okType : 'button-positive',
                cancelType : 'button-positive button-outline'
            });

            confirm.then(function (res) {
                var req = {
                    url : host + '/api/v2/reset-password',
                    method : 'POST',
                    data : $scope.reset,
                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                };

                $http(req).then(function successCallback (output) {
                    var response = output.data;
                    if (response.status == 'success') {
                        window.localStorage.setItem("user", JSON.stringify(response.data));
                        $rootScope.userinfo = response.data;
                        $scope.showToast(response.message);
                        $scope.reset = {};
                        $scope.modal_reset.hide();
                    }
                    else {
                        $scope.showAlert("Failed", response.message);
                    }
                }, function errorCallback (err) {
                    $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                })
            }, function () {

            });
        }
        $scope.refreshProfile = function () {
            var req = {
                url : host + '/api/v2/view-profile',
                method : 'GET',
                params : {token : userinfo.token}
            }
            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.profile = response.data.profile;
                    $scope.profile_edit = response.data.profile;
                    $scope.applicant = response.data.profile;
                    $scope.awards = response.data.awards;
                    $scope.character_references = response.data.character_references;
                    $scope.interests = response.data.interests;
                    $scope.objectives = response.data.objectives;
                    $scope.skills = response.data.skills;
                    $scope.schools = response.data.schools;
                    $scope.languages = $scope.applicant.languages ? $scope.applicant.languages.split(',') : [];
                    $scope.experiences = response.data.experiences;
                    $scope.attainments = response.data.attainments;
                    $scope.app_skills = response.data.app_skills;
                    $scope.seminars = response.data.seminars;
                    $scope.affiliations = response.data.affiliations;

                    $scope.image_changed = false;
                    $scope.applicant.original_picture = response.data.profile.photo ? $scope.img_dir + '/account/' + response.data.profile.photo : '';
                    $scope.applicant.profile_picture = response.data.profile.photo ? $scope.img_dir + '/account/' + response.data.profile.photo : '';

                    // for (i in $scope.skills) {
                    //     $scope.skills_arr.push($scope.skills[i].spec_id);
                    // }
                }
                else {
                    $scope.showAlert("Failed", response.message);
                }
                $scope.hideLoading();
                $scope.$broadcast('scroll.refreshComplete');
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        $scope.refreshProfile();

        $scope.editProfile = function () {
            $scope.cities = cities;

            $scope.profile_edit = {};
            $scope.profile_edit.account_id = $scope.profile.account_id;
            $scope.profile_edit.applicant_id = $scope.profile.applicant_id;
            $scope.profile_edit.attain_id = $scope.profile.attain_id;
            $scope.profile_edit.birthdate = $scope.profile.birthdate;
            $scope.profile_edit.call_experience = $scope.profile.call_experience;
            $scope.profile_edit.card_no = $scope.profile.card_no;
            $scope.profile_edit.city_municipality = $scope.profile.city_municipality;
            $scope.profile_edit.created_at = $scope.profile.created_at;
            $scope.profile_edit.date_registered = $scope.profile.date_registered;
            $scope.profile_edit.download_type = $scope.profile.download_type;
            $scope.profile_edit.drivers_license = $scope.profile.drivers_license;
            $scope.profile_edit.email_address = $scope.profile.email_address;
            $scope.profile_edit.emp_status = $scope.profile.emp_status;
            $scope.profile_edit.first_name = $scope.profile.first_name;
            $scope.profile_edit.gender = $scope.profile.gender;
            $scope.profile_edit.graduate_type = $scope.profile.graduate_type;
            $scope.profile_edit.home_address = $scope.profile.home_address;
            $scope.profile_edit.job_preference = $scope.profile.job_preference;
            $scope.profile_edit.landline = $scope.profile.landline;
            $scope.profile_edit.languages = $scope.profile.languages;
            $scope.profile_edit.last_name = $scope.profile.last_name;
            $scope.profile_edit.last_work_exp = $scope.profile.last_work_exp;
            $scope.profile_edit.middle_name = $scope.profile.middle_name;
            $scope.profile_edit.mobile_1 = $scope.profile.mobile_1;
            $scope.profile_edit.mobile_2 = $scope.profile.mobile_2;
            $scope.profile_edit.no_work_exp = $scope.profile.no_work_exp;
            $scope.profile_edit.original_picture = $scope.profile.original_picture;
            $scope.profile_edit.photo = $scope.profile.photo;
            $scope.profile_edit.profile_picture = $scope.profile.profile_picture;
            $scope.profile_edit.total_print = $scope.profile.total_print;
            $scope.profile_edit.updated_at = $scope.profile.updated_at;
            $scope.profile_edit.work_call = $scope.profile.work_call;
            $scope.modal_edit_profile.show();
        }

        $scope.remove_experience = function (id, idx) {
            $scope.experiences.splice(idx, 1);
        }

        $scope.changePicture = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Select Image Source',
                okType : 'button-positive',
                okText : '<i class="icon ion-camera"></i>',
                cancelType : 'button-positive button-outline',
                cancelText : '<i class="icon ion-images"></i>'
            });

            confirmPopup.then(function(res) {
                if(res) {
                    t = 1;
                } else {
                    t = 0;
                }
                document.addEventListener("deviceready", function () {
                    var options = {
                      quality: 80,
                      destinationType: Camera.DestinationType.FILE_URI,
                      sourceType: t,
                      allowEdit: false,
                      encodingType: Camera.EncodingType.JPEG,
                      targetWidth: 300,
                      targetHeight: 300,
                      popoverOptions: CameraPopoverOptions,
                      saveToPhotoAlbum: false,
                      correctOrientation:true
                    };

                    $cordovaCamera.getPicture(options).then(function(imageUrl) {
                      var confirm = $ionicPopup.confirm({
                        title : "Are you sure you want to update your picture?",
                        template : "<img src="+ imageUrl +" width='100%'>",
                      });
                      confirm.then(function (res) {
                        if (res) {
                            $scope.savePicture(imageUrl);
                        }
                      });

                    }, function(err) {
                      $scope.applicant.profile_picture = '';
                    });
                });
            });
        }

        $scope.savePicture = function (filePath) {
            $scope.showLoading();
            var options = {};
            options.fileKey = 'image';
            options.params = {token : userinfo.token};
            document.addEventListener('deviceready', function () {
            $cordovaFileTransfer.upload(host + '/api/v2/update-picture', filePath, options)
              .then(function(result) {
                var response = JSON.parse(result.response);

                //resetting the session
                var userinfo = JSON.parse(window.localStorage.getItem("user"));
                userinfo.photo = response.data.picture;
                window.localStorage.setItem("user", JSON.stringify(userinfo));

                $rootScope.userinfo = userinfo;
                $scope.applicant.updated_at = response.data.updated_at;
                $scope.applicant.photo = response.data.picture;
                $scope.hideLoading();
                $scope.showToast(response.message);
              }, function(err) {
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                $scope.hideLoading();
              }, function (progress) {
              });

          }, false);
        }

        $scope.revertPicture = function () {
            $scope.image_changed = false;
            $scope.applicant.profile_picture = $scope.applicant.original_picture;
        }

        $scope.uploadDocuments = function () {
            var req = {
                url : host + '/api/v2/document-types',
                method : 'GET',
                params : {token : userinfo.token}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.data = response.data;
                    $scope.app_docs = [];
                    for (i in response.data.appdocs) {
                        $scope.app_docs.push(response.data.appdocs[i].doc_type_id);
                    }
                }
                else {
                    $scope.showAlert("Failed", response.message);
                }
            }, function errorCallback (err) {

            })
            $scope.modal_document.show();
        }

        $scope.checkDocument = function (id) {
          if ($scope.app_docs.indexOf(id) >= 0) {
            return true;
          }
          else {
            return false;
          }
        }

        $scope.viewDocumentDetails = function (i) {
            var confirm = $ionicPopup.confirm({
                title : 'Document Details',
                template : '<img width="100%" src="'+ $scope.img_dir + '/documents/' + $scope.profile.applicant_id + '/' + i.filename +'"">',
                okType : 'button-positive',
                okText : 'Download',
                cancelType : 'button-positive button-outline',
                cancelText : 'Close',
            });

            confirm.then(function (res) {
                if (res) {
                    $scope.showLoading();
                    document.addEventListener('deviceready', function () {
                    var url = $scope.img_dir + '/documents/' + $scope.profile.applicant_id + '/' + i.filename;
                    var targetPath = cordova.file.externalRootDirectory + "/Download/" + i.filename;
                    var trustHosts = true;
                    var options = {};

                    $cordovaFileTransfer.download(url, targetPath, options, trustHosts)
                      .then(function(result) {
                        $ionicLoading.hide().then(function(){
                            $scope.hideLoading();
                            $cordovaFileOpener2.open(
                                targetPath,
                                'image/jpeg'
                            ).then(function() {
                                  // Success!
                            }, function(err) {
                                  // An error occurred. Show a message to the user
                            });
                        });
                      }, function(err) {
                        $scope.showToast("Something went wrong. Please try again")
                      }, function (progress) {
                        $timeout(function () {
                          $scope.downloadProgress = (progress.loaded / progress.total) * 100;
                        });
                      });

                   }, false);
                }
            })
        }

        $scope.countDocs = function (id) {
            var count = 0;
            for (i in $scope.app_docs) {
                if ($scope.data.appdocs[i].doc_type_id == id) {
                    count += 1;
                }
            }
            return count;
        }

        $scope.viewDocument = function (id, type) {
            $scope.doc_details = {};
            $scope.doc_details.id = id;
            $scope.doc_details.type = type;
            $scope.doc_details.documents = [];
            for (i in $scope.data.appdocs) {
                if ($scope.data.appdocs[i].doc_type_id == id) {
                    $scope.doc_details.documents.push($scope.data.appdocs[i]);
                }
            }
            $scope.modal_uploaded_document.show();
        }

        $scope.chooseDocument = function () {
            var id = $scope.doc_details.id;
            var confirmPopup = $ionicPopup.confirm({
                title: 'Select Image Source',
                okType : 'button-positive',
                okText : '<i class="icon ion-camera"></i>',
                cancelType : 'button-positive button-outline',
                cancelText : '<i class="icon ion-images"></i>'
            });

            confirmPopup.then(function(res) {
                if(res) {
                    t = 1;
                } else {
                    t = 0;
                }
                document.addEventListener("deviceready", function () {
                    var options = {
                      quality: 70,
                      destinationType: Camera.DestinationType.FILE_URI,
                      sourceType: t,
                      allowEdit: false,
                      encodingType: Camera.EncodingType.JPEG,
                      targetWidth: 1000,
                      targetHeight: 1000,
                      popoverOptions: CameraPopoverOptions,
                      saveToPhotoAlbum: false,
                      correctOrientation:true
                    };

                    $cordovaCamera.getPicture(options).then(function(imageUrl) {
                      // $scope.data.documentTypes[idx].image_changed = true;
                      // $scope.data.documentTypes[idx].image_document = imageUrl;
                      var confirm = $ionicPopup.confirm({
                        title : 'Are you sure you want to upload this image?',
                        template : '<img width="100%" src="'+ imageUrl +'">',
                        okType : 'button-positive',
                        cancelType : 'button-positive button-outline',
                        okText : 'Upload',
                        cancelText : 'Close'
                      });

                      confirm.then(function (res) {
                        if (res) {
                            $scope.uploadDocumentProcess(id, imageUrl);
                        }
                      });

                    }, function(err) {
                      $scope.applicant.profile_picture = '';
                    });
                });
            });
        }

        $scope.uploadDocumentProcess = function (id, img) {
          $scope.showLoading();
          var file_path = img;
          var options = {};
          options.fileKey = 'doc_image';
          options.params = {token : userinfo.token, id : id};
          $cordovaFileTransfer.upload(host + '/api/v2/upload-document', file_path, options)
          .then(function(result) {
              var response = JSON.parse(result.response);
              if ($scope.app_docs.indexOf(id) == -1) {
                $scope.app_docs.push(id);
              }

              if (response.status == 'success') {
                $scope.data.appdocs.push(response.data);
                $scope.doc_details.documents.push(response.data);
                $scope.uploadDocuments();
              }
              $scope.hideLoading();
              $scope.showToast(response.message);
            }, function(err) {
              $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
              $scope.hideLoading();
            }, function (progress) {
          });
        }

        $scope.chooseFile = function (t) {
            var myPath = cordova.file.externalRootDirectory;
            window.resolveLocalFileSystemURL(myPath, function (dirEntry) {
                 var directoryReader = dirEntry.createReader();
                 directoryReader.readEntries(function (data) {
                    alert(JSON.stringify(data));
                 }, function (err) {
                    alert(err)
                 });
            });
        }

        $scope.updateProfile = function () {
            var error = '';
            if (!$scope.profile_edit.home_address) {
                error += '-Home Address<br/>';
            }
            if (!$scope.profile_edit.city_municipality) {
                error += '-City/Municipality<br/>';
            }
            if (!$scope.profile_edit.gender) {
                error += '-Gender';
            }
            if (error) {
                $scope.showAlert("Required Fields", "Following Fields are required. <br/>" + error);
                return false;
            }
            $scope.showLoading();
            $scope.profile_edit.token = userinfo.token;
            var req = {
                url : host + '/api/v2/update-profile',
                method : 'POST',
                data : $scope.profile_edit,
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.applicant = response.data;
                    $scope.profile = response.data;
                    $scope.profile_edit = response.data;

                    $scope.showToast(response.message);
                    $scope.modal_edit_profile.hide();
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                $scope.hideLoading();
            });
        }

        $scope.addObjectiveDisplay = function () {
            $scope.objective_type = 'add';
            $scope.objective = {};
            $scope.modal_objective.show();
        }

        $scope.addObjective = function () {
            if ($scope.objective_type == 'add') {
                $scope.showLoading();
                var req = {
                    url : host + '/api/v2/add-objective',
                    method : 'POST',
                    data : {
                        token : userinfo.token,
                        objective : $scope.objective.description
                    },
                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                }

                $http(req).then(function successCallback (output) {
                    var response = output.data;
                    if (response.status == 'success') {
                        $scope.objective = {};
                        $scope.objectives.push(response.data);
                        $scope.modal_objective.hide();
                        $scope.showToast(response.message);
                    }
                    $scope.hideLoading();
                }, function errorCallback (err) {
                    $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                    $scope.hideLoading();
                });
            }
            else {
                $scope.showLoading();
                var req = {
                    url : host + '/api/v2/update-objective',
                    method : 'POST',
                    data : {
                        token : userinfo.token,
                        objective : $scope.objective.description,
                        id : $scope.objective.id
                    },
                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                }

                $http(req).then(function successCallback (output) {
                    var response = output.data;
                    if (response.status == 'success') {
                        var obj_idx = $scope.objectives.indexOf($scope.objective.data);
                        $scope.objectives[obj_idx] = response.data;
                        $scope.hideLoading();
                        $scope.showToast(response.message);
                        $scope.modal_objective.hide();
                    }
                    else {
                        $scope.showAlert("Failed", response.message);
                    }
                }, function errorCallback (err) {
                    $scope.hideLoading();
                    $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                })
            }
        }

        $scope.editObjective = function (i) {
            $scope.objective = {};
            $scope.objective.description = i.objective_description;
            $scope.objective.id = i.objective_id;
            $scope.objective.data = i;
            $scope.objective_type = 'edit';
            $scope.modal_objective.show();
        }

        $scope.removeObjective = function(id, idx) {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Remove Objective',
                template: 'You cannot undo this action in the future.<br/> Are you sure you want to continue?',
                okType : 'button-assertive'
            });

            confirmPopup.then(function(res) {
                if(res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-objective/' + id,
                        method : 'POST',
                        data: {token : userinfo.token},
                        headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                    }

                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.objectives.splice(idx, 1);
                            $scope.showToast(response.message);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.showLoading();
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                    });
                } else {
                    console.log('You are not sure');
                }
            });
        }

        $scope.addEducationOption = function () {
            $scope.education = {};
            $scope.education.type = 'add';
            $scope.modal_education.show();
        }
        $scope.addEducation = function () {
            $scope.showLoading();
            $scope.education.token = userinfo.token;
            var req = {
                url : host + '/api/v2/add-school/' + $scope.applicant.applicant_id,
                method : 'POST',
                data : $scope.education,
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    if ($scope.education.type == 'add') {
                        $scope.schools.push(response.data);
                    }
                    else {
                        $scope.schools[$scope.education.idx] = response.data;
                    }
                    
                    $scope.education = {};
                    $scope.showToast(response.message);
                    $scope.modal_education.hide();
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            })
        }

        $scope.updateAttainment = function (i) {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Update Educational Attainment',
                template: 'Are you sure?',
                okType : 'button-positive'
            });

            confirmPopup.then(function(res) {
                if(res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/update-educational-attainment',
                        method : 'POST',
                        data : {token : userinfo.token, id : i.attain_id},
                        headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                    };

                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.applicant.attain_id = response.data.attain_id;
                            $scope.hideLoading();
                            //$scope.showToast(response.message);
                            $scope.modal_attainment.hide();
                        }
                    }, function errorCallback (err) {

                    })
                } else {
                    console.log('You are not sure');
                }
            });
        }

        $scope.deleteEducation = function (id, idx) {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Remove Educational Details',
                template: 'You cannot undo this action in the future.<br/> Are you sure you want to continue?',
                okType : 'button-assertive'
            });

            confirmPopup.then(function(res) {
                if(res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-school',
                        method : 'POST',
                        data: {token : userinfo.token, id : id},
                        headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                    }

                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.schools.splice(idx, 1);
                            $scope.showToast(response.message);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.hideLoading();
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                    });
                } else {
                    console.log('You are not sure');
                }
            });
        }

        $scope.setDate = function(t) {
            var options = {
                date: new Date(),
                mode: 'date', // or 'time'
                minDate: 0,
                allowOldDates: true,
                allowFutureDates: true,
                doneButtonLabel: 'DONE',
                doneButtonColor: '#F2F3F4',
                cancelButtonLabel: 'CANCEL',
                cancelButtonColor: '#000000'
            };

            document.addEventListener("deviceready", function () {

            $cordovaDatePicker.show(options).then(function(date){
                if (t == 'start') {
                    $scope.exp.start_date = moment(date).format('YYYY-MM-DD');
                }
                else {
                    $scope.exp.end_date = moment(date).format('YYYY-MM-DD');
                }
            }, function () {
                $scope.exp.end_date = null;
            });

            }, false);
        }

        $scope.addExpOption = function () {
            $scope.exp = {};
            $scope.exp.type = 'add';
            $scope.modal_experience.show();
        }

        $scope.addExperience = function () {
            $scope.exp.applicant_id = $scope.applicant.applicant_id;
            $scope.exp.token = userinfo.token;
            $scope.showLoading();

            if ($scope.exp.current) {
                $scope.exp.end_date = null;
            }
            var req = {
                url : host + '/api/v2/add-experience',
                method : 'POST',
                data : $scope.exp,
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    if ($scope.exp.type == 'add') {
                        $scope.experiences.push(response.data);    
                    }
                    else {
                        $scope.experiences[$scope.exp.idx] = response.data;
                    }
                    $scope.exp = {};
                    $scope.modal_experience.hide();
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
            });

        }

        $scope.updateGradType = function () {
            $scope.showLoading();
            var req = {
                url : host + '/api/v2/update-graduate-type',
                method : 'POST',
                data : { token : $scope.userinfo.token, type : $scope.applicant.graduate_type},
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.showToast(response.message);
                    $scope.applicant.graduate_type = response.data.graduate_type;
                }
                else {
                    $scope.showAlert("Failed", response.message);
                }
                $scope.hideLoading();
            }, function (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            });
        }

        $scope.updateWorkingExperience = function () {
            var no_exp = $scope.applicant.no_work_exp;
            var last_exp = $scope.applicant.no_work_exp == 1 ? 0 : 1;

            $scope.showLoading();
            var req = {
                url : host + '/api/v2/update-working-experience',
                method : 'POST',
                data : {token : $scope.userinfo.token, no_exp : no_exp, last_exp : last_exp},
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.showToast(response.message);
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            })
        }

        $scope.updateEmploymentStatus = function (i) {
            $scope.showLoading();
            var req = {
                url : host + '/api/v2/update-employment-status',
                method : 'POST',
                data : {status : i.name, token : userinfo.token},
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            };

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.applicant.emp_status = response.data.emp_status;
                    $scope.showToast(response.message);
                    $scope.hideLoading();
                    $scope.modal_emp_status.hide();
                }
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            })
        }

        $scope.chooseAction = function (i, idx, type) {
            console.log(i);
            var popup = $ionicPopup.show({
                    title : 'Choose your action',
                    template : 'Please select the action that you want to do.',
                    buttons : [
                        {
                            text : 'Edit',
                            type : 'button-positive',
                            onTap : function () {
                                if (type == 'exp') {
                                    $scope.exp = {};
                                    $scope.exp.type = 'edit';
                                    $scope.exp.idx = idx;
                                    $scope.exp.id = i.app_comp_id;
                                    $scope.exp.company = i.company;
                                    $scope.exp.position = i.position;
                                    $scope.exp.job_description = i.job_description;
                                    $scope.exp.start_date = moment(i.from).format('MMM DD, YYYY');
                                    $scope.exp.end_date = i.to ? moment(i.to).format('MMM DD, YYYY') : '';
                                    $scope.modal_experience.show();    
                                }
                                else if (type == 'sch') {
                                    $scope.education = {};
                                    $scope.education.school = i.school;
                                    $scope.education.course = i.course;
                                    $scope.education.year_graduated = parseInt(i.yr_graduated);
                                    $scope.education.id=i.school_id;
                                    $scope.education.type = 'edit';
                                    $scope.education.idx = idx;

                                    $scope.modal_education.show();
                                }
                                else if (type == 'ref'){
                                    $scope.ref = {};
                                    $scope.ref.type = 'edit';
                                    $scope.ref.idx = idx;
                                    $scope.ref.id = i.reference_id;
                                    $scope.ref.name = i.name;
                                    $scope.ref.job_title = i.job_title;
                                    $scope.ref.contact = parseInt(i.contact_no  );
                                    $scope.modal_reference.show();
                                }
                                else if (type == 'int') {
                                    $scope.editInterest(i);
                                }
                                else if (type == 'obj') {
                                    $scope.editObjective(i);
                                }
                                else if (type == 'aw') {
                                    $scope.editAward(i, idx);
                                }
                                else if (type == 'ski') {
                                    $scope.editAppSkill(i, idx);
                                }
                                else if (type == 'sem') {
                                    $scope.seminar = i;
                                    $scope.seminar.type = 'edit';
                                    $scope.seminar.index = idx;
                                    $scope.modal_seminar.show();
                                }
                                else if (type == 'afi') {
                                    $scope.affiliation = i;
                                    $scope.affiliation.index = idx;
                                    $scope.affiliation.type == 'edit';
                                    $scope.modal_affiliation.show();
                                }
                            }
                        },
                        {
                            text : 'Delete',
                            type : 'button-assertive',
                            onTap : function () {
                                if (type == 'exp') {
                                    $scope.remove_experience(i.app_comp_id, idx);
                                }
                                else if (type == 'sch') {
                                    $scope.deleteEducation(i.school_id, idx);
                                }
                                else if (type == 'ref'){
                                    $scope.deleteReference(i.reference_id, idx);
                                }
                                else if (type == 'int'){
                                    $scope.deleteInterest(i.interest_id, idx);
                                }
                                else if (type == 'obj') {
                                    $scope.removeObjective(i.objective_id, idx);
                                }
                                else if (type == 'aw') {
                                    $scope.deleteAward(i.award_id, idx);
                                }
                                else if (type == 'ski') {
                                    $scope.deleteAppSkill(i.skill_id, idx);
                                }
                                else if (type == 'sem') {
                                    $scope.deleteSeminar(i.idx, idx);
                                }
                                else if (type == 'afi') {
                                    $scope.deleteAffiliation(i.idx, idx);
                                }
                            }
                        }
                    ] 
                });
        }

        $scope.remove_experience = function (id, idx) {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Remove Experience Record',
                template: 'You cannot undo this action in the future.<br/> Are you sure you want to continue?',
                okType : 'button-assertive'
            });

            confirmPopup.then(function (res) {
                if (res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-experience',
                        method : 'GET',
                        params : {token : userinfo.token, id : id},
                    };

                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.experiences.splice(idx, 1);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.hideLoading();
                    });
                }
            }, function () {

            });
        }

        $scope.showLanguage = function () {
            var myPopup = $ionicPopup.show({
                template: '<input type="text" ng-model="app.language" placeholder="Enter your language here..">',
                title: 'Enter your language',
                subTitle: '(eg. English)',
                scope: $scope,
                buttons: [
                  { text: 'Cancel', type: 'button-positive button-outline'},
                  {
                    text: '<b>Save</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                      if (!$scope.app.language) {
                        $scope.showToast("Please enter your language");
                        e.preventDefault();
                      } else {
                        var index = $scope.languages.indexOf($scope.app.language);
                        if (index < 0 ) {
                            var languages = $scope.languages;
                            languages.push($scope.app.language);
                            $scope.showLoading();
                            var req = {
                                url : host + '/api/v2/update-language',
                                method : 'POST',
                                data : {token : userinfo.token, languages : languages.join(','), applicant_id : $scope.applicant.applicant_id},
                                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                            }
                            $http(req).then(function successCallback (output) {
                                var response = output.data;
                                if (response.status == 'success') {
                                    $scope.languages = response.data.split(",");
                                }
                                $scope.hideLoading();
                            }, function errorCallback (err) {

                            })
                            $scope.languages.push($scope.app.language);
                        }
                        else {
                            $scope.showToast("Item already exist");
                            e.preventDefault();
                        }
                      }
                    }
                  }
                ]
            });
        }

        $scope.deleteLanguage = function (idx) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete Language',
                template : 'You cannot undo this action.<br/> Are you sure you want to continue?',
                okType : 'button-assertive'
            });

            confirm.then(function (res) {
                if (res) {
                    if ($scope.languages.length > 1) {
                        $scope.languages.splice(idx, 1);
                        new_language = $scope.languages.join(',');
                    }
                    else {
                        new_language = '';
                    }

                    var req = {
                        url : host + '/api/v2/update-language',
                        method : 'POST',
                        data : {token: userinfo.token, applicant_id : $scope.applicant.applicant_id, languages : new_language},
                        headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                    }
                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.languages = response.data ? response.data.split(',') : [];
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.hideLoading();
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                    });
                }
            }, function () {

            })
        }

        $scope.addInterestDisplay = function () {
            $scope.interest = {};
            $scope.interest_type = 'add';
            $scope.modal_interest.show();
        }
        $scope.editInterest = function (i) {
            $scope.interest.id = i.interest_id;
            $scope.interest.description = i.interest_description;
            $scope.interest.data = i;
            $scope.interest_type = 'edit';
            $scope.modal_interest.show();
        }

        $scope.addInterest = function () {
            if ($scope.interest_type == 'add') {
                $scope.showLoading();
                var req = {
                    url : host + '/api/v2/add-interest',
                    method : 'POST',
                    data : {interest : $scope.interest.description, applicant_id : $scope.applicant.applicant_id, token : userinfo.token},
                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                }

                $http(req).then(function successCallback (output) {
                    var response = output.data;
                    if (response.status == 'success') {
                        $scope.interests.push(response.data);
                        $scope.interest = {};
                        $scope.modal_interest.hide();
                    }
                    $scope.hideLoading();
                }, function errorCallback (err) {
                    $scope.hideLoading();
                });
            }
            else {
                $scope.showLoading();
                $scope.interest.token = $scope.userinfo.token;
                var req = {
                    url : host + '/api/v2/update-interest',
                    method : 'POST',
                    data : $scope.interest,
                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                };
                $http(req).then(function successCallback (output) {
                    var response = output.data;
                    if (response.status == 'success') {
                        var idx = $scope.interests.indexOf($scope.interest.data);
                        $scope.interests[idx] = response.data;
                        $scope.showToast(response.message);
                        $scope.interest = {};
                        $scope.modal_interest.hide();
                    }
                    else {
                        $scope.showAlert("Failed", response.message);
                    }
                    $scope.hideLoading();
                }, function error (err) {
                    $scope.hideLoading();
                    $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                })
            }
        }

        $scope.deleteInterest = function (id, idx) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete Language',
                template : 'You cannot undo this action.<br/> Are you sure you want to continue?',
                okType : 'button-assertive'
            });

            confirm.then(function (res) {
                $scope.showLoading();
                var req = {
                    url : host + '/api/v2/delete-interest/' + id,
                    method : 'GET',
                    params : {token: userinfo.token}
                }
                $http(req).then(function successCallback (output) {
                    var response = output.data;
                    if (response.status == 'success') {
                        $scope.interests.splice(idx, 1);
                    }
                    $scope.hideLoading();
                }, function errorCallback (err) {
                    $scope.hideLoading();
                });
            });
        }

        $scope.addReferenceOption = function () {
            $scope.ref = {};
            $scope.ref.type = 'add';
            $scope.modal_reference.show();
        }

        $scope.addReference = function () {
            $scope.ref.token = userinfo.token;
            $scope.ref.applicant_id = $scope.applicant.applicant_id;
            $scope.showLoading();

            var req = {
                url : host + '/api/v2/add-reference',
                method : 'POST',
                data : $scope.ref,
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    if ($scope.ref.type ==  'add') {
                        $scope.character_references.push(response.data);    
                    }
                    else {
                        $scope.character_references[$scope.ref.idx] = response.data;
                    }
                    $scope.ref = {};
                    $scope.modal_reference.hide();
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
            });
        }

        $scope.deleteReference = function (id, idx) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete Reference',
                template : 'You cannot undo this action.<br/> Are you sure you want to continue?',
                okType : 'button-assertive'
            });

            confirm.then(function (res) {
                if (res) {
                    var req = {
                        url : host + '/api/v2/delete-reference/' + id,
                        method : 'GET',
                        params : {token : userinfo.token}
                    }
                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.character_references.splice(idx, 1);
                        }
                        $scope.showToast(response.message);
                    }, function errorCallback (err) {
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                    })
                }
            });
        }

        $scope.addSkill = function () {
            $scope.others = false;
            $scope.custom_spec = {};
            $scope.showLoading();
            var req = {
                url : host + '/api/v2/get-specializations',
                method : 'POST',
                data : {token : userinfo.token},
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.specializations = response.data;
                    $scope.modal_skill.show();
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            });
        }

        $scope.select_specialization = function (s) {
            var idx = $scope.skills_arr.indexOf(s.spec_id);
            if (idx >= 0) {
                $scope.deleted_skills_arr.push(s.spec_id);
                $scope.skills_arr.splice(idx, 1);

                if (s.title == 'Others' || s.title == 'others') {
                    $scope.others = false;
                }
            }
            else {
                $scope.skills_arr.push(s.spec_id);
                if (s.title == 'Others' || s.title == 'others') {
                    $scope.others = true;
                }
            }
        }

        $scope.check_skill = function (id) {
            for (i in $scope.skills) {
                if ($scope.skills[i].spec_id == id) {
                    if (id == 16) {
                        $scope.others = true;
                        $scope.custom_spec.others_desc = $scope.skills[i].others;    
                    }
                    return true;
                }
            }
            return false;
        }

         $scope.submit = function () {
            if ($scope.check_skill(16) || $scope.others) {
                others = 1;   
            }
            else {
                others = 0;
            }
            var req = {
                url : host + '/api/v2/add-specializations',
                method : 'POST',
                data : {
                    skills : $scope.skills_arr, 
                    token : userinfo.token, 
                    applicant_id : $scope.applicant.applicant_id,
                    hasOthers : others,
                    otherDesc : $scope.custom_spec.others_desc ? $scope.custom_spec.others_desc : '',
                },
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.skills = response.data;
                    $scope.skills_arr = [];
                    $scope.others = false;
                    $scope.modal_skill.hide();
                }
                else {
                    $scope.showAlert("Failed", response.message);
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            })
        }

        $scope.deleteSkill = function (id, idx) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete Specialization',
                template : 'You cannot undo this action.<br/> Are you sure you want to continue?',
                okType : 'button-assertive'
            });

            confirm.then(function (res) {
                if (res) {
                    var req = {
                        url : host + '/api/v2/delete-specializations/' + id,
                        method : 'GET',
                        params : {token: userinfo.token, applicant_id : $scope.applicant.applicant_id}
                    }
                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.skills.splice(idx, 1);
                            $scope.skills_arr = [];
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.hideLoading();
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                    })
                }
            }, function () {

            })
        }

        $scope.addAppSkill = function () {
            $scope.appskill = {};
            $scope.appskill.token = $scope.userinfo.token;
            var popup = $ionicPopup.show({
                title : '<strong>Add skill record</strong>',
                template : '<input type="text" placeholder="Enter your skill" ng-model="appskill.skill">',
                scope : $scope,
                buttons : [
                    {
                        text : 'Save',
                        type : 'button-positive',
                        onTap : function (e) {
                            $scope.showLoading();
                            if (!$scope.appskill.skill) {
                                e.preventDefault();
                            }
                            else {
                                var req = {
                                    url : host + '/api/v2/add-app-skill',
                                    method : 'POST',
                                    data : $scope.appskill,
                                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                                };

                                $http(req).then(function successCallback (output) {
                                    var response = output.data;
                                    if (response.status == 'success') {
                                        $scope.app_skills.push(response.data);
                                    }
                                    $scope.hideLoading();
                                }, function errorCallback (err) {
                                    $scope.hideLoading();
                                    $scope.showToast("Server connection error");
                                })
                            }
                        }
                    },
                    {
                        text : 'Cancel',
                        type : 'button-positive button-outline'
                    }
                ]
            });
        }

        $scope.editAppSkill = function (i, idx) {
            $scope.appskill = {};
            $scope.appskill.skill_id = i.skill_id;
            $scope.appskill.skill = i.skill;
            $scope.appskill.token = $scope.userinfo.token;

            var popup = $ionicPopup.show({
                title : '<strong>Update Skill Info</strong>',
                template : '<input type="text" placeholder="Enter your skill" ng-model="appskill.skill">',
                scope : $scope,
                buttons : [
                    {
                        text : 'Save',
                        type : 'button-positive',
                        onTap : function (e) {
                            if (!$scope.appskill.skill) {
                                $scope.showToast("Please enter your skill.");
                                e.preventDefault();
                            }
                            else {
                                $scope.showLoading();
                                var req = {
                                    url : host + '/api/v2/edit-app-skill',
                                    method : 'POST',
                                    data : $scope.appskill,
                                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                                }

                                $http(req).then(function successCallback (output) {
                                    var response = output.data;
                                    if (response.status == 'success') {
                                        $scope.app_skills[idx] = response.data;
                                    }
                                    $scope.hideLoading();
                                }, function errorCallback (err) {
                                    $scope.hideLoading();
                                    $scope.showToast("Server connection error");
                                });
                            }
                        }
                    },
                    {
                        text : 'Cancel',
                        type : 'button-positive button-outline'
                    }
                ]
            })
        }

        $scope.deleteAppSkill = function (id, idx) {
            var confirm = $ionicPopup.confirm({
                title : '<strong>Delete skill record</strong>',
                template : 'Are you sure you want to delete this skill record?',
                okType : 'button-assertive',
                cancelType : 'button-assertive button-outline'
            });
            confirm.then(function (res) {
                if (res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-app-skill',
                        method : 'GET',
                        params : {token : $scope.userinfo.token, id : id}
                    }

                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.app_skills.splice(idx, 1);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.hideLoading();
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                    })
                }
            });
        }

        $scope.getAge = function (bdate) {
            birthday = new Date(bdate);
            var ageDifMs = Date.now() - birthday.getTime();
            var ageDate = new Date(ageDifMs); // miliseconds from epoch
            return Math.abs(ageDate.getUTCFullYear() - 1970);
        }

        $scope.setBirthDate = function () {
            var options = {
                date: new Date(),
                mode: 'date', // or 'time'
                minDate: 0,
                allowOldDates: true,
                allowFutureDates: true,
                doneButtonLabel: 'DONE',
                doneButtonColor: '#F2F3F4',
                cancelButtonLabel: 'CANCEL',
                cancelButtonColor: '#000000'
            };

            $cordovaDatePicker.show(options).then(function(date){
                $scope.profile_edit.birthdate = moment(date).format('YYYY-MM-DD');
            });
        }

        $scope.setAwardYear = function (y) {
            $scope.award.award_date = y + '-' + '01-01';
            $scope.modal_award_year.hide();
        }

        $scope.setAwardDate = function  () {
            var options = {
                date: new Date(),
                mode: 'date', // or 'time'
                minDate: 0,
                allowOldDates: true,
                allowFutureDates: true,
                doneButtonLabel: 'DONE',
                doneButtonColor: '#F2F3F4',
                cancelButtonLabel: 'CANCEL',
                cancelButtonColor: '#000000'
            };

            $cordovaDatePicker.show(options).then(function(date){
                $scope.award.award_date = moment(date).format('YYYY-MM-DD');
            });
        }
        var dateNow = new Date();
        $scope.award = {};
        $scope.award.award_date = moment(dateNow).format('YYYY');
        $scope.saveAward = function () {
            $scope.showLoading();
            $scope.award.token = userinfo.token;
            $scope.award.applicant_id = $scope.applicant.applicant_id;
            var req = {
                url : host + '/api/v2/add-award',
                method : 'POST',
                data : $scope.award,
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            };
            $http(req).then(function successCallback(output) {
                var response = output.data;
                if (response.status == 'success') {
                    if ($scope.award.type == 'add') {
                        $scope.awards.push(response.data);
                    }
                    else {
                        $scope.awards[$scope.award.idx] = response.data;
                    }
                    $scope.modal_award.hide();
                    $scope.award = {};
                }
                $scope.showToast(response.message);
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            })
        }

        $scope.addAward = function () {
            $scope.award = {};
            $scope.award.type = 'add';
            $scope.modal_award.show();
        }

        $scope.editAward = function (i, idx) {
            $scope.award = {};
            $scope.award.idx = idx;
            $scope.award.type = 'edit';
            $scope.award.id = i.award_id;
            $scope.award.award_title = i.award_title;
            $scope.award.award_date = moment(i.award_date).format("YYYY-MM-DD");
            $scope.modal_award.show();
        }

        $scope.deleteAward = function (id, idx) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete Award',
                template : 'You cannot do this action, are you sure you want to continue?',
                okType : 'button-assertive',
                cancelType : 'button-assertive button-outline'
            });
            confirm.then(function (res) {
                if (res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-award/' + id,
                        method : 'GET',
                        params : {token : userinfo.token}
                    };

                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.showToast(response.message);
                            $scope.awards.splice(idx, 1);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                        $scope.hideLoading();
                    })
                }
            })
        }

        $scope.updateInfo = function () {
            $scope.showLoading();
            $scope.applicant.token = userinfo.token;
            var req = {
                url : host + '/api/v2/update-personal-info',
                method : 'POST',
                data : $scope.applicant,
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            };
            $http(req).then(function successCallback (output) {
                var response = output.data;
                $scope.showToast(response.message);
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            })
        }

        $scope.getAttainment = function (id) {
            for (i in $scope.attainments) {
                if ($scope.attainments[i].attain_id == id) {
                    return $scope.attainments[i].description;
                }
            }
        }

        $scope.addSeminar = function () {
            $scope.seminar = {};
            $scope.seminar.date_from = '2017-01-01';
            $scope.seminar.date_to = '2017-01-02';
            $scope.seminar.type = 'add';
            $scope.modal_seminar.show();
        }

        $scope.setSeminarDate = function (type) {
            var options = {
                date: new Date(),
                mode: 'date', // or 'time'
                minDate: 0,
                allowOldDates: true,
                allowFutureDates: true,
                doneButtonLabel: 'DONE',
                doneButtonColor: '#F2F3F4',
                cancelButtonLabel: 'CANCEL',
                cancelButtonColor: '#000000'
            };

            $cordovaDatePicker.show(options).then(function(date){
                if (type == 'from') {
                   $scope.seminar.date_from = moment(date).format('YYYY-MM-DD'); 
                }
                else {
                    $scope.seminar.date_to = moment(date).format('YYYY-MM-DD');
                }
            });
        }

        $scope.saveSeminar = function () {
            $scope.showLoading();
            $scope.seminar.token = userinfo.token;
            var req = {
                url : host + '/api/v2/save-seminar',
                method : 'POST',
                data : $scope.seminar,
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            };

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    if ($scope.seminar.type == 'add') {
                       $scope.seminars.push(response.data); 
                    }
                    else {
                        $scope.seminars[$scope.seminar.index] = response.data;
                    }
                }
                else {
                    $scope.showToast(response.message);
                }

                $scope.modal_seminar.hide();
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            })
        }

        $scope.deleteSeminar = function (id, idx) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete Seminar',
                template : 'Are you sure you want to delete this record?',
                okType : 'button-assertive',
                cancelType : 'button-stable',
                okText : 'Yes',
                cancelText : 'Cancel'
            });

            confirm.then(function (res) {
                if (res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-seminar',
                        method : 'GET',
                        params : {token : userinfo.token, id : id}
                    };

                    $http(req).then(function successCallback(output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.seminars.splice(idx, 1);
                        }
                        else {
                            $scope.showToast(response.message);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.hideLoading();
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                    });
                }
            });
        }

        $scope.setAffiliationDate = function (type) {
            var options = {
                date: new Date(),
                mode: 'date', // or 'time'
                minDate: 0,
                allowOldDates: true,
                allowFutureDates: true,
                doneButtonLabel: 'DONE',
                doneButtonColor: '#F2F3F4',
                cancelButtonLabel: 'CANCEL',
                cancelButtonColor: '#000000'
            };

            $cordovaDatePicker.show(options).then(function(date){
                if (type == 'from') {
                   $scope.affiliation.date_from = moment(date).format('YYYY-MM-DD'); 
                }
                else {
                    $scope.affiliation.date_to = moment(date).format('YYYY-MM-DD');
                }
            });
        }

        $scope.addAffiliation = function () {
            $scope.affiliation = {};
            $scope.affiliation.type = 'add';
            $scope.affiliation.date_from = '2017-01-01';
            $scope.affiliation.date_to = '2017-01-01';
            $scope.modal_affiliation.show();
        }

        $scope.submitAffiliation = function () {
            $scope.showLoading();
            $scope.affiliation.token = userinfo.token;
            var req = {
                url : host + '/api/v2/save-affiliation',
                method : 'POST',
                data : $scope.affiliation,
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            };

            $http(req).then(function successCallback(output) {
                var response = output.data;
                if (response.status == 'success') {
                    if ($scope.affiliation.type == 'add') {
                        $scope.affiliations.push(response.data);    
                    }
                    else {
                        $scope.affiliations[$scope.affiliation.index] = response.data;
                    }
                }
                $scope.modal_affiliation.hide();
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            });
        }

        $scope.deleteAffiliation = function (id, idx) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete Affiliation Record',
                template : 'Are you sure you want to delete this record?',
                okType : 'button-assertive',
                cancelType : 'button-stable',
                okText : 'Yes',
                cancelText : 'Cancel'
            });

            confirm.then(function (res) {
                if (res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-affiliation',
                        method : 'GET',
                        params : {token : userinfo.token, id : id}
                    };

                    $http(req).then(function successCallback(output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.affiliations.splice(idx, 1);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.hideLoading();
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                    });
                }
            });
        }

        $scope.current_year = moment(datenow).format('YYYY');
        $scope.selected_year = moment(datenow).format('YYYY');
        $scope.selected_month = 1;

        $scope.setExpMonth = function (month) {
            $scope.selected_month = month;
        }

        $scope.setExpYear = function (y) {
            if ($scope.current_year >= $scope.selected_year) {
                $scope.selected_year = parseInt($scope.selected_year) + y;
            }
        }

        $scope.openMonthPicker = function (type) {
            $scope.selected_month = 1;
            $scope.selected_year = moment(datenow).format('YYYY');

            var myPopup = $ionicPopup.show({
            templateUrl: 'templates/modal/month-picker.html',
            title: 'Select Month and Year',
            scope: $scope,
            buttons: [
                {
                    text : 'Cancel'
                },
              {
                text: '<b>Save</b>',
                type: 'button-positive',
                onTap: function(e) {
                    var exp_date = new Date($scope.selected_month + ' 01,' + $scope.selected_year);
                    if (type == 'start') {
                        $scope.exp.start_date = moment(exp_date).format('YYYY-MM-DD');
                    }
                    else {
                        $scope.exp.end_date = moment(exp_date).format('YYYY-MM-DD');;
                    }
                }
              }
            ]
          });
        }

        $scope.Math = window.Math;
        $scope.city_page = 1;
        $scope.city_offset = 0;

        $scope.cityPaginate = function (p) {
            $scope.city_page = $scope.city_page + p;
            $scope.city_offset = ($scope.city_page * 10) - 10;
        }

        $scope.cityReset = function () {
            $scope.city_page = 1;
            $scope.city_offset = 0;
        }

        $scope.selectCity = function (c) {
            $scope.profile_edit.city_municipality = c.city_name;
            $scope.modal_cities.hide();
        }
    }
])
.controller('contactMeiCtrl', ['$scope', '$http', '$state','$ionicPopup',
    function ($scope, $http, $state, $ionicPopup) {
        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        $scope.showLoading();
        var req = {
            url : host + '/api/v2/contact-mei',
            method : 'GET',
            params : {token : userinfo.token}
        }

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.messages = response.data;
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
        });

        $scope.addMessage = function () {
            $state.go('app.contact-mei-add');
        }

        $scope.deleteMessage = function (id, idx) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete message',
                template : 'You cannot do this action, are you sure you want to continue?',
                okType : 'button-positive',
                cancelType : 'button-positive button-outline'
            });
            confirm.then(function (res) {
                if (res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-message/' + id,
                        method : 'GET',
                        params : {token : userinfo.token}
                    };

                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.showToast(response.message);
                            $scope.messages.splice(idx, 1);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                        $scope.hideLoading();
                    })
                }
            })
        }
    }
])
.controller('ContactMeiDetailsCtrl', ['$scope', '$http', '$state', '$stateParams',
    function ($scope, $http, $state, $stateParams) {
        var userinfo = JSON.parse(window.localStorage.getItem("user"));

        $scope.showLoading();

        var req = {
            url : host + '/api/v2/view-message',
            method : 'GET',
            params : {id : $stateParams.id, token : userinfo.token}
        }

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.message = response.data;
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
        });
    }
])
.controller('ContactMeiAddCtrl', ['$scope', '$http', '$state', '$ionicHistory',
    function ($scope, $http, $state, $ionicHistory) {
        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        $scope.message = {};

        $scope.sendMessage = function () {
            $scope.showLoading()
            var req = {
                url : host + '/api/v2/send-message',
                method : 'POST',
                data : {subject : $scope.message.subject, message : $scope.message.content, token : userinfo.token, company_id : $stateParams.id},
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    $scope.showToast(response.message)
                    $ionicHistory.goBack(-1);
                }
                else {
                    $scope.showAlert("Failed", response.message);
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                $scope.hideLoading();
            })
        }
    }
])
.controller('ContactMeiChatCtrl', ['$scope', '$http', '$ionicModal', '$ionicScrollDelegate', '$rootScope', '$stateParams',
    function ($scope, $http, $ionicModal, $ionicScrollDelegate, $rootScope, $stateParams) {
        $ionicModal.fromTemplateUrl('templates/modal/add-message.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_message = modal;
        });

        $scope.showLoading();
        $scope.message = {};

        var req = {
            url : host + '/api/v2/get-mei-messages',
            method : 'GET',
            params : {token : $scope.userinfo.token, company_id : $stateParams.id}
        }
        
        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                if ($stateParams.id == 0) {
                    $scope.company = {
                        company_name : 'Magnus Eventus Inc.',
                        logo : 'img/mei-logo.png',
                        owner : 'Admin'
                    };
                }
                else {
                    $scope.company = {
                        company_name : response.data.company.company_name,
                        logo : $scope.img_dir + '/company/' + response.data.company.logo,
                        owner : 'Company'
                    };
                }
                $rootScope.messages = response.data.messages;
                $ionicScrollDelegate.scrollBottom(true);
            }
            else {
                $scope.showAlert("Failed", response.message);
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            $scope.hideLoading();
        });


        $scope.refreshMessage = function () {
            var req = {
                url : host + '/api/v2/get-mei-messages',
                method : 'GET',
                params : {token : $scope.userinfo.token, company_id : $stateParams.id}
            }
            
            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    if ($stateParams.id == 0) {
                        $scope.company = {
                            company_name : 'Magnus Eventus Inc.',
                            logo : 'img/mei-logo.png',
                            owner : 'Admin'
                        };
                    }
                    else {
                        $scope.company = {
                            company_name : response.data.company.company_name,
                            logo : $scope.img_dir + '/company/' + response.data.company.logo,
                            owner : 'Company'
                        };
                    }
                    $rootScope.messages = response.data.messages;
                    $ionicScrollDelegate.scrollBottom(true);
                }
                else {
                    $scope.showAlert("Failed", response.message);
                }
                $scope.$broadcast('scroll.refreshComplete');
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                $scope.hideLoading();
            });
        }

        $scope.addMessage = function () {
            $scope.message.content = '';
            $scope.modal_message.show();
        }

        $scope.sendMessage = function () {
            $scope.showLoading();
            var req = {
                url : host + '/api/v2/send-mei-message',
                method : 'POST',
                data : {message : $scope.message.content, token : $scope.userinfo.token, company_id : $stateParams.id},
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }

            $http(req).then(function successCallback (output) {
                $scope.hideLoading();
                var response = output.data;
                if (response.status == 'success') {
                    $scope.messages.push(response.data);
                    $scope.modal_message.hide();

                    setTimeout(function () {
                        $scope.showToast(response.message);
                        $ionicScrollDelegate.scrollBottom(true);
                    }, 500);
                }
                else {
                    $scope.showAlert("Failed", response.message);
                }
            }, function errorCallback (err) {
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                $scope.hideLoading();
            })
        }
    }
])
.controller('notificationsCtrl', ['$scope', '$http', '$state', '$ionicPopup', '$rootScope',
    function ($scope, $http, $state, $ionicPopup, $rootScope) {
        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        $scope.showLoading();
        var req = {
            url : host + '/api/v2/get-notifications',
            method : 'GET',
            params : {token : userinfo.token}
        };

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.notifications = response.data;
            }
            $rootScope.unread = 0;
            for (i in response.data) {
                if (response.data[i].is_read == 0 && response.data[i].applicant_id) {
                    $rootScope.unread += 1;
                }
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
        });

        $scope.deleteNotification = function (id, idx) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete notification',
                template : 'You cannot do this action, are you sure you want to continue?',
                okType : 'button-positive',
                cancelType : 'button-positive button-outline'
            });
            confirm.then(function (res) {
                if (res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-notification/' + id,
                        method : 'GET',
                        params : {token : userinfo.token}
                    };

                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.showToast(response.message);
                            $scope.notifications.splice(idx, 1);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                        $scope.hideLoading();
                    })
                }
            })
        }
    }
])
.controller('notificationViewCtrl', ['$scope', '$http', '$stateParams', 
    function ($scope, $http, $stateParams) {
        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        $scope.showLoading();
        var req = {
            url : host + '/api/v2/view-notification/' + $stateParams.id,
            method : 'GET',
            params : {token : userinfo.token}
        };
        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.details = response.data;
            }
            else {
                $scope.showAlert("Failed", response.message);
            }

            $scope.hideLoading()
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
        });      
    }
])
.controller('referralCtrl', ['$scope', '$http', '$state', '$ionicPopup', '$ionicModal',
    function ($scope, $http, $state, $ionicPopup, $ionicModal) {
        $ionicModal.fromTemplateUrl('templates/modal/referral.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_referral = modal;
        });
        $ionicModal.fromTemplateUrl('templates/modal/educ-attainment.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_attainment = modal;
        });

        $scope.Math = window.Math;
        $scope.showLoading();
        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        var req = {
            url : host + '/api/v2/get-referrals',
            method : 'GET',
            params : {token : userinfo.token}
        }

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.referrals = response.data.referrals;
                $scope.total_prints = response.data.printed;
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
        });

        $scope.ref = {};
        $scope.addRef = function () {
            $scope.ref = {};
            $scope.ref.type = 'add';
            $scope.modal_referral.show();
        }

        $scope.educAttainment = function () {
            $scope.showLoading();
            var req = {
                url : host + '/api/v2/get-educational-attainments',
                method : 'GET',
                params : {token : userinfo.token}
            }

            $http(req).then(function successCallback(output) {
                var response = output.data;

                if (response.status == 'success') {
                    $scope.attainments = response.data;
                    $scope.modal_attainment.show();
                    $scope.hideLoading();
                }
                else {
                    $scope.showToast(response.message);
                }
            }, function errorCallback(err) {
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                $scope.hideLoading();
            });
        }

        $scope.updateAttainment = function (a) {
            $scope.ref.attainment = a.description;
            $scope.modal_attainment.hide();
        }   

        $scope.editRef = function (obj, idx) {
            console.log(obj);
            $scope.ref = {};
            $scope.ref.idx = idx;
            $scope.ref.name = obj.name;
            $scope.ref.notes = obj.notes;
            $scope.ref.mobile = parseInt(obj.mobile);
            $scope.ref.ref_id = obj.ref_id;
            $scope.ref.type = 'edit';
            $scope.ref.idx = idx;
            $scope.modal_referral.show();
        }

        $scope.submitRef = function () {
            $scope.ref.token  = userinfo.token;
            if ($scope.ref.type == 'add') {
                var text = 'Note: You cannot change or delete this record once it\'s saved.<br/>';
                text += "<br/>Are you sure you want continue?";
                var confirm = $ionicPopup.confirm({
                    title : 'Save Record',
                    template : text,
                    okType : 'button-positive',
                    cancelType : 'button-stable',
                    okText : 'Yes',
                    cancelText : 'Cancel'
                });
                confirm.then(function (res) {
                    if (res) {
                        $scope.showLoading();
                        var req = {
                            url : host + '/api/v2/add-referral',
                            method : 'POST',
                            data : $scope.ref,
                            headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                        }
                        $http(req).then(function successCallback (output) {
                            var response = output.data;
                            if (response.status == 'success') {
                                $scope.ref = {};
                                $scope.referrals.push(response.data);
                                $scope.modal_referral.hide();
                            }
                            else {
                                $scope.showAlert("Failed", response.message);
                            }
                            $scope.hideLoading();
                        }, function errorCallback (err) {
                            $scope.hideLoading();
                        });
                    }
                });
            }
            else {
                $scope.showLoading();
                var req = {
                    url : host + '/api/v2/update-referral',
                    method : 'POST',
                    data : $scope.ref,
                    headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                }
                $http(req).then(function successCallback (output) {
                    var response = output.data;
                    if (response.status == 'success') {
                        $scope.referrals[$scope.ref.idx] = response.data;
                        $scope.ref = {};
                        $scope.modal_referral.hide();
                    }
                    $scope.hideLoading();
                }, function errorCallback (err) {
                    $scope.hideLoading();
                })
            }
        }

        $scope.viewRef = function (r) {
            var notes = r.notest ? r.notes : '-';
            var text = 'Name : ' + r.name;
            text += '<br/>Mobile No: ' + r.mobile;

            if (r.ref_position){
                text += '<br/>Position: ' + r.ref_position;
            }
            if (r.ref_educAttain) {
                text += '<br/>Education: ' + r.ref_educAttain;
            }
            if (notes) {
                text += '<br/>Notes: ' + notes;
            }
            $scope.showAlert("Referral Information", text);
        }

        $scope.deleteRef = function (id, idx) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete Referral',
                template : 'You cannot do this action, are you sure you want to continue?',
                okType : 'button-positive',
                cancelType : 'button-positive button-outline'
            });
            confirm.then(function (res) {
                if (res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-referral/' + id,
                        method : 'GET',
                        params : {token : userinfo.token}
                    };

                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            $scope.showToast(response.message);
                            $scope.referrals.splice(idx, 1);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                        $scope.hideLoading();
                    })
                }
            })
        }
    }
])
.controller('aboutCtrl', ['$scope', '$http', '$ionicHistory', '$ionicAuth', '$timeout', '$state',
    function ($scope, $http, $ionicHistory, $ionicAuth, $timeout, $state) {
        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        var req = {
            url : host + '/api/v2/about',
            method : 'GET',
            params : {token : userinfo.token}
        }

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.about = response.data;
            }
            else {
                $scope.showToast("Failed", response.message);
                $timeout(function () {
                    $ionicHistory.clearCache();
                    $ionicHistory.clearHistory();
                },300)

                if ($scope.userinfo.registration_type == 'facebook') {
                    $ionicAuth.logout();
                }
                window.localStorage.setItem("user", "");
                $state.go('login');
            }
        }, function errorCallback (err) {

        })
    }
])
.controller('searchJobCtrl', ['$scope', '$http', '$ionicHistory', '$ionicAuth', '$timeout', '$state', '$ionicModal',
    function ($scope, $http, $ionicHistory, $ionicAuth, $timeout, $state, $ionicModal) {
        $ionicModal.fromTemplateUrl('templates/modal/job-details.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_job = modal;
        });

        $scope.Math = window.Math;
        $scope.page = 1;
        $scope.offset = ($scope.page * 5) - 5;
        $scope.prov_page = 1;
        $scope.prov_offset = 0;
        $scope.exclu_page = 1;
        $scope.exclu_offset = 0;
        $scope.feat_page = 1;
        $scope.feat_offset = 0;

        var userinfo = JSON.parse(window.localStorage.getItem("user"));
        $scope.showLoading();
        var req = {
            url : host + '/api/v2/search-jobs',
            method : 'GET',
            params : {token : userinfo.token}
        }

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.data = {};
                $scope.data.mega = [];
                $scope.data.provincial = [];
                $scope.data.exclusive = response.data.exclusive;
                $scope.data.featured = response.data.featured;

                for (i in response.data.events) {
                    if (response.data.events[i].category_id == 1) {
                        $scope.data.mega.push(response.data.events[i]);
                    }
                    else if (response.data.events[i].category_id == 2) {
                        $scope.data.provincial.push(response.data.events[i]);
                    }
                }
            }
            else {
                $scope.showAlert("Failed", response.message);
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
        });
        
        $scope.viewJobDetails = function (i) {
            $scope.job = i;
            $scope.modal_job.show();
        }

        $scope.paginate = function (p) {
            $scope.page = $scope.page + p;
            $scope.offset = ($scope.page * 5) - 5;
        }

        $scope.prov_paginate = function (p) {
            $scope.prov_page = $scope.prov_page + p;
            $scope.prov_offset = ($scope.prov_page * 5) - 5;
        }

        $scope.exclu_paginate = function (p) {
            $scope.exclu_page = $scope.exclu_page + p;
            $scope.exclu_offset = ($scope.exclu_page * 5) - 5;
        }

        $scope.feat_paginate = function (p) {
            $scope.feat_page = $scope.feat_page + p;
            $scope.feat_offset = ($scope.feat_page * 5) - 5;
        }

        $scope.apply = function (category, id) {
            if (category == 3) {
                $state.go('app.view-company-event', {id : id});
            }
            else if (category == 4) {
                $state.go('app.view-featured-company', {id : id});
            }
            else {
                $state.go('app.view-event', {id : id, category : category});
            }
        }
    }
])
.controller('imHiredCtrl', ['$scope', '$http','$ionicModal', '$ionicPopup', '$cordovaDatePicker',
    function ($scope, $http, $ionicModal, $ionicPopup, $cordovaDatePicker) {
        $ionicModal.fromTemplateUrl('templates/modal/add-hired-info.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_hired = modal;
        });


        $ionicModal.fromTemplateUrl('templates/modal/companies.html', {
            scope : $scope,
            animation : 'slide-in-up'
        }).then(function(modal) {
            $scope.modal_company = modal;
        });

        $scope.emp = {};

        $scope.showLoading();
        var req = {
            url : host + '/api/v2/get-employments',
            method : 'GET',
            params : {token : $scope.userinfo.token}
        }

        $http(req).then(function successCallback (output) {
            var response = output.data;
            if (response.status == 'success') {
                $scope.employment_info = response.data.employments;
                $scope.companies = response.data.companies;
            }
            else {
                $scope.showAlert("Failed", response.message);
            }
            $scope.hideLoading();
        }, function errorCallback (err) {
            $scope.hideLoading();
            $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
        });

        $scope.getCompanies = function () {
            $scope.modal_company.show();
        }

        $scope.setCompany = function (c) {
            $scope.emp.company_name = c.company_name;
            $scope.emp.company_id = c.company_id;
            $scope.modal_company.hide();
        }

        $scope.addInfo = function () {
            $scope.emp = {};
            $scope.emp.type = 'add';
            $scope.modal_hired.show();
        };

        $scope.editInfo = function (i) {
            $scope.emp = {};
            $scope.emp.hired_id = i.hired_id;
            $scope.emp.company_name = i.company_name;
            $scope.emp.position = i.position;
            $scope.emp.date_hired = i.date_hired;
            $scope.emp.data = i;
            $scope.emp.type = 'edit';
            $scope.modal_hired.show();
        }

        $scope.deleteInfo = function (i) {
            var confirm = $ionicPopup.confirm({
                title : 'Delete Employement Info',
                template : 'Are you sure you want to delete this employment info?',
                okType : 'button-assertive',
                cancelType : 'button-assertive button-outline',
                okText : 'Yes',
                cancelText : 'No'
            });
            confirm.then(function (res) {
                if (res) {
                    $scope.showLoading();
                    var req = {
                        url : host + '/api/v2/delete-employment-info',
                        method : 'POST',
                        data : {token : $scope.userinfo.token, id : i.hired_id},
                        headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
                    }
                    $http(req).then(function successCallback (output) {
                        var response = output.data;
                        if (response.status == 'success') {
                            var idx = $scope.employment_info.indexOf(i);
                            $scope.employment_info.splice(idx, 1);
                        }
                        else {
                            $scope.showAlert("Failed", response.message);
                        }
                        $scope.hideLoading();
                    }, function errorCallback (err) {
                        $scope.hideLoading();
                        $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
                    });
                }
            })
        };

        $scope.setDateHired = function () {
            var options = {
                date: new Date(),
                mode: 'date', // or 'time'
                minDate: 0,
                allowOldDates: true,
                allowFutureDates: true,
                doneButtonLabel: 'DONE',
                doneButtonColor: '#F2F3F4',
                cancelButtonLabel: 'CANCEL',
                cancelButtonColor: '#000000'
            };

            document.addEventListener("deviceready", function () {
                $cordovaDatePicker.show(options).then(function(date){
                    $scope.emp.date_hired = moment(date).format('MMM DD, YYYY');
                });
            }, false);
        }
       
        $scope.saveInfo = function () {
            $scope.showLoading();
            $scope.emp.token = $scope.userinfo.token;
            var req = {
                url : host + '/api/v2/save-employment-info',
                method : 'POST',
                data : $scope.emp,
                headers : {'Content-Type' : 'application/x-www-form-urlencoded'}
            }
            $http(req).then(function successCallback (output) {
                var response = output.data;
                if (response.status == 'success') {
                    if ($scope.emp.type == 'add') {
                        $scope.employment_info.push(response.data);
                    }
                    else {
                        var idx = $scope.employment_info.indexOf($scope.emp.data);
                        $scope.employment_info[idx] = response.data;
                    }
                    $scope.showToast(response.message);
                    $scope.modal_hired.hide();
                }
                else {
                    $scope.showAlert("Failed", response.message);
                }
                $scope.hideLoading();
            }, function errorCallback (err) {
                $scope.hideLoading();
                $scope.showToast("Connection Failed. \n Please check your internet connection and try again.");
            });
        }
    }
])